#include "nds_asm.h"
#include "equates.h"
#include "ARMZ80/z80mac.h"
//#include "ARMZ80/armz80.h"

	.arm
	.align 4
	.section .text

	.global loadcart
	.global ejectCart
	.global HuMapper_
	.global packState
	.global unpackState
	.global g_emuflags
	.global romstart
	.global romnum
//	.global scaling
	.global g_scaling_set
	.global g_cartflags
	.global g_machine
	.global g_machine_set
//	.global g_config
	.global g_config_set
	.global g_region
	.global BankMap4
	.global g_dipswitch0
	.global g_dipswitch1
	.global g_dipswitch2
	
	.global BankSwitchR_W
	.global BankSwitch0_W
	.global BankSwitch1_W
	.global BankSwitch2_W
	.global BankSwitch0C_W
	.global BankSwitch1C_W
	.global BankSwitch2C_W
/*
	.global reBankSwitchB_W
	.global reBankSwitchR_W
	.global reBankSwitch0_W
	.global reBankSwitch1_W
	.global reBankSwitch2_W
	.global reBankSwitch0C_W
*/
	.global BankSwitch0MSX_W
	.global BankSwitch1MSX_W
	.global BankSwitch2MSX_W
	.global BankSwitch3MSX_W

	.global BankSwitchB_GG_W
	.global MemCtrl_SMS_W

	.global EMU_RAM
	.global EMU_SRAM
	.global ROM_Space
	.global BIOS_US_Space
	.global BIOS_JP_Space
	.global BIOS_GG_Space
	.global g_BIOSBASE_US
	.global g_BIOSBASE_JP
	.global g_BIOSBASE_GG
	.global g_ROM_Size

rawrom:
//	.incbin "sms/Ace of Aces (UE) [!].sms"
//	.incbin "sms/After Burner (UE).sms"
//	.incbin "sms/Alex Kidd in Miracle World [v1].sms"
//	.incbin "sms/Battlemaniacs (BR) [!].sms"
//	.incbin "sms/Cosmic Spacehead (UE) [!].sms"
//	.incbin "sms/Fire & Forget 2 (UE) [!].sms"
//	.incbin "sms/Gauntlet (UE) [!].sms"
//	.incbin "sms/Out Run.sms"
//	.incbin "sms/Phantasy Star [v3].sms"
//	.incbin "sms/Running Battle (UE) [!].sms"
//	.incbin "sms/Terminator, The (UE) [!].sms"
//	.incbin "sms/VDPTest.sms"
//	.incbin "gg/Barbie Super Model [Proto].gg"
//	.incbin "gg/Aerial Assault [v0].gg"
//	.incbin "gg/Aerial Assault [v1].gg"
//	.incbin "gg/X-Men - Mojo World (UE) [!].gg"
//	.incbin "gg/twisty.gg"
//	.incbin "sg/Bank Panic.sg"
//	.incbin "sg/Bomb Jack.sg"
//	.incbin "sg/Castle, The (JP).sg"
//	.incbin "sg/Congo Bongo [B].sg"
rawbios:
//	.incbin "SMS BIOS (US v1.3).sms"


;@----------------------------------------------------------------------------
loadcart: 		;@ called from C:  r0=rom number, r1=emuflags
;@----------------------------------------------------------------------------
	stmfd sp!,{r0-r1,r4-r11,lr}

	ldr z80optbl,=Z80_optable
@	ldr r1,=findrom
@	bl thumbcall_r1

//	ldr r3,=rawbios
//	str r3,g_BIOSBASE_US
//	ldr r3,=rawrom
	ldr r3,=ROM_Space

	ldmfd sp!,{r0-r1}
	str r0,romnum
	str r1,g_emuflags
	ldrb r0,g_machine_set
	strb r0,g_machine
	ldrb r0,g_config_set
	strb r0,g_config

//	ldrb r0,g_emuflags
//	orr r0,r0,#GG_MODE
//	orr r0,r0,#SG_MODE
//	strb r0,g_emuflags

								;@ r3=rombase til end of loadcart so DON'T FUCK IT UP
	str r3,rombase				;@ set rom base
	str r3,cartbase				;@ set rom base

	ldr r1,g_ROM_Size
//	mov r1,#0x80000
	cmp r1,#0x006000			;@ Mahjong, SG-1000 fix
	moveq r1,#0x008000			;@ -||-
	cmp r1,#0x00A000			;@ Monaco GP, SG-1000 fix
	moveq r1,#0x010000			;@ -||-
	cmp r1,#0x00C000			;@ Home Mahjong, SG-1000 fix
	moveq r1,#0x010000			;@ -||-
	cmp r1,#0x06C000			;@ Dodgeball fix
	moveq r1,#0x080000			;@ -||-
	cmp r1,#0x090000			;@ SF2 fix
	movhi r1,#0x100000			;@ -||-
	movs r2,r1,lsr#13			;@ Rom size in 8k banks
	subne r2,r2,#1
	str r2,rommask				;@ rommask=romsize-1
	str r2,rommask_backup		;@ rommask=romsize-1

	mov r0,r3
	bl MapperDetect
	mov r5,r0

	ldr r1,=0x02010000
	str r1,BankMap_Bios

	cmp r2,#0x4					;@ 32kB
	ldrmi r1,=0x02010008		;@ RAM for SG1000 games
	cmp r0,#1
	ldreq r1,=0x00010000		;@ Codemaster...
	str r1,BankMap_Cart
	str r1,BankMap0

	ldr r4,=MEMMAPTBL_
	ldr r9,=RDMEMTBL_
	ldr r6,=WRMEMTBL_
	ldr r7,=rom_R
	ldrmi r8,=rom_W
	ldreq r8,=Codemaster_W
	ldrhi r8,=Korean_W
	cmp r0,#3
	ldreq r8,=Korean_MSX_W
	mov r0,#0
tbloop1:
	and r1,r0,r2
	add r1,r3,r1,lsl#14
	str r1,[r4,r0,lsl#2]
	str r7,[r9,r0,lsl#2]
	str r8,[r6,r0,lsl#2]
	add r0,r0,#1
	cmp r0,#8
	bne tbloop1

	bl FillROMBANKMAP
	bl CheckMachine				;@ returns HW_Machine in r0.
	mov r9,r0

	ldr r0,g_emuflags
	ldrb r2,g_config
	mov r1,#0
	cmp r9,#HW_SMS1
	cmpne r9,#HW_SMS2
	ldreq r1,g_BIOSBASE_US		;@ SMS
	tst r0,#COUNTRY
	ldrne r1,g_BIOSBASE_JP		;@ SMS
	cmp r9,#HW_GG
	ldreq r1,g_BIOSBASE_GG		;@ GG
	bicne r2,r2,#0x40			;@ R as Start only on HW_GG
	bicne r0,r0,#GG_MODE
	cmpne r9,#HW_MD
	biceq r2,r2,#0x20			;@ Reset unavailable on HW_GG & HW_MD
	tst r0,#GG_MODE
	bicne r0,r0,#0x300			;@ Unscaled mode in GG_MODE
	str r0,g_emuflags
	strb r2,g_config
	cmp r1,#0
	moveq r1,r3
	str r1,biosbase
	mov r0,#7					;@ 7 BIOS
	str r1,[r4,r0,lsl#2]		;@ MemMap
	str r8,[r6,r0,lsl#2]		;@ WrMem

	cmp r9,#HW_SG1000
	ldrne r8,=ram0_W
	ldreq r8,=ram2_W			;@ 2k RAM mirrored
	ldr r1,=EMU_RAM
	mov r0,#3					;@ 3 RAM
	str r1,[r4,r0,lsl#2]		;@ MemMap
	str r8,[r6,r0,lsl#2]		;@ WrMem

	beq is_sg_ram
	ldr r8,=ram1_W				;@ RAM without bankswitch
	cmp r5,#0
	bne is_sg_ram
	ldr r0,rommask
	cmp r0,#4
	ldrpl r8,=ram1S_W			;@ RAM with bank switch
is_sg_ram:
	mov r0,#4					;@ 4 RAM mirror
	str r1,[r4,r0,lsl#2]		;@ MemMap
	str r8,[r6,r0,lsl#2]		;@ WrMem

	ldr r1,=EMU_SRAM-0x8000
	ldr r8,=sram0_W				;@ 5 SRAM
	mov r0,#5					;@ 5 SRAM page 0
	str r1,[r4,r0,lsl#2]		;@ MemMap
	str r8,[r6,r0,lsl#2]		;@ WrMem

	ldr r1,=EMU_SRAM-0x4000
	ldr r8,=sram1_W				;@ 6 SRAM
	mov r0,#6					;@ 6 SRAM page 1
	str r1,[r4,r0,lsl#2]		;@ MemMap
	str r8,[r6,r0,lsl#2]		;@ WrMem


	ldrb r1,g_config
	tst r1,#0x80				;@ BIOS on/off
	cmpne r9,#HW_SG1000
	cmpne r9,#HW_MD
	moveq r4,#0xAB				;@ Map in cartridge
	movne r4,#0xE3				;@ Map in BIOS

	strb r4,BankMap4			;@ address bus chipselects.
	bl InitMapper_
	bl reBankSwitch0_W
	bl reBankSwitch1_W
	bl reBankSwitch2_W
	bl reBankSwitchB_W

@	ldmfd sp!,{r0}
@	cmp r0,#0
@	bne NoMemClear
	bl Mem_reset
	ldr r0,=EMU_RAM
	strb r4,[r0]				;@ simulate BIOS tag.
	mov r0,#0
NoMemClear:
	bl GFX_reset
	bl IO_reset
	bl Sound_reset
	bl CPU_reset
	ldmfd sp!,{r4-r11,lr}
	bx lr

;@----------------------------------------------------------------------------
ejectCart:
;@----------------------------------------------------------------------------
	mov r2,#0x100000
	str r2,g_ROM_Size
	movs r1,r2,lsr#13			;@ Rom size in 8k banks
	subne r1,r1,#1
	str r1,rommask				;@ rommask=romsize-1
	str r1,rommask_backup		;@ rommask=romsize-1

	ldr r0,=ROM_Space
	mov r1,#-1
	mov r2,#0x100000/4
	b memset_

;@----------------------------------------------------------------------------
Mem_reset:
;@----------------------------------------------------------------------------
	stmfd sp!,{r4-r9,r11,lr}

	ldr r0,=DISABLEDMEM			;@ reset disabled memory
	mov r1,#-1
	mov r2,#0x400/4
	bl memset_

	ldr r0,=WRAP_RAM			;@ fix for "Aerial Assault [v0].gg"
	ldr r1,=0xC7C7C7C7
	mov r2,#8/4
	bl memset_

	ldr r0,=EMU_SRAM			;@ clear SRAM
	mov r1,#0
	mov r2,#0x8000/4
	bl memset_

	ldrb r11,g_machine_set
	cmp r11,#HW_AUTO
	moveq r6,#0
	movne r6,#-1
	mov r2,r6,lsl#16
	mov r3,r6,lsr#16
	ldr r0,=VDP_RAM				;@ clear VDP RAM.
	mov r1,#0x4000/8
vramLoop:
	subs r1,r1,#1
	stmplia r0!,{r2,r3}
	bhi vramLoop

	mov r2,#0
	mov r3,r2
	mov r7,r6
	stmfd sp!,{r2,r3,r6,r7}
	ldmfd sp!,{r4,r5,r8,r9}
	ldr r0,=EMU_RAM				;@ clear SMS RAM.
	cmp r11,#HW_SMS2
	beq WRAM_SMS2
	mov r1,#0x2000/64
wramLoop0:
	subs r1,r1,#1
	stmplia r0!,{r2-r5}
	stmplia r0!,{r2-r5}
	stmplia r0!,{r6-r9}
	stmplia r0!,{r6-r9}
	bhi wramLoop0

	ldmfd sp!,{r4-r9,r11,lr}
	bx lr

WRAM_SMS2:
	mov r2,#0x2000/0x100
wramLoop2:
	mov r1,#0x100/32
wramLoop1:
	subs r1,r1,#1
	stmplia r0!,{r6-r9}
	stmplia r0!,{r6-r9}
	bhi wramLoop1
	mvn r6,r6
	mvn r7,r7
	mvn r8,r8
	mvn r9,r9
	subs r2,r2,#1
	bhi wramLoop2

	ldmfd sp!,{r4-r9,r11,lr}
	bx lr
;@----------------------------------------------------------------------------
CheckMachine:				;@ returns machine in r0.
;@----------------------------------------------------------------------------
	ldr r0,rombase
	add r0,r0,#0x8000
	ldrb r2,[r0,#-1]
	and r2,r2,#0xF0
	ldrb r0,g_machine
	cmp r0,#HW_AUTO
	bne CM_NoCheck
	ldrb r1,g_emuflags
	tst r1,#SG_MODE
	movne r0,#HW_SG1000
	bne CM_SetMachine
	tst r1,#MD_MODE
	movne r0,#HW_MD
	bne CM_SetMachine
	and r1,r1,#GG_MODE
	cmp r1,#GG_MODE
	beq CM_NoGGCheck
	stmfd sp!,{r2,lr}
	bl CheckForHeader
	ldmfd sp!,{r2,lr}
	cmp r0,#0
	movne r2,#0
	cmp r2,#0x50				;@ GG Japan
	cmpne r2,#0x60				;@ GG Export
	cmpne r2,#0x70				;@ GG International
CM_NoGGCheck:
	moveq r0,#HW_GG
	beq CM_SetMachine
	cmp r2,#0x40				;@ SMS Export
	moveq r0,#HW_SMS2
	movne r0,#HW_SMS1
CM_SetMachine:
	strb r0,g_machine
CM_NoCheck:
	ldrb r1,g_region
	cmp r1,#REGION_AUTO
	beq CM_CheckRegion
	ldrb r2,g_emuflags
	sub r1,r1,#1
	bic r2,r2,#3
	orr r2,r2,r1
	strb r2,g_emuflags
	bx lr
CM_CheckRegion:
	ldrb r1,g_emuflags
	cmp r2,#0x40				;@ SMS Export
	bicne r1,r1,#PALTIMING		;@ clear PAL bit
	cmpne r2,#0x60				;@ GG Export
	cmpne r2,#0x70				;@ GG International
	orrne r1,r1,#COUNTRY		;@ set JP bit
	biceq r1,r1,#COUNTRY		;@ clear JP bit
	strb r1,g_emuflags

	bx lr

;@----------------------------------------------------------------------------
CheckForHeader:				;@ returns r0=0 if header found.
;@----------------------------------------------------------------------------
	ldr r1,rombase
	add r1,r1,#0x8000
	ldr r0,[r1,#-0x10]
	ldr r2,=0x20524D54			;@ "TMR "
	subs r0,r0,r2
	ldreq r0,[r1,#-0x0C]
	ldreq r2,=0x41474553		;@ "SEGA"
	subeqs r0,r0,r2
	bx lr
;@----------------------------------------------------------------------------
FillROMBANKMAP:
;@----------------------------------------------------------------------------
	stmfd sp!,{r2-r4,lr}

	ldr r3,rombase				;@ Get rom base
	ldr r2,rommask				;@ rommask=romsize-1

	ldr r4,=ROMBANKMAP
	mov r0,#0xFF
tbloop0:
	and r1,r0,r2
	add r1,r3,r1,lsl#13			;@ 8k banks
	str r1,[r4,r0,lsl#2]
	subs r0,r0,#1
	bpl tbloop0

	ldmfd sp!,{r2-r4,lr}
	bx lr

;@----------------------------------------------------------------------------
InitMapper_:				;@ rom paging..
;@----------------------------------------------------------------------------
	ldr r2,=WRMEMTBL_
	ldr r1,=Z80_memwritetbl

	ldr r0,[r2]
	str r0,[r1],#4				;@ Z80_memwritetbl, WRITE_ROM
	str r0,[r1],#4				;@ Z80_memwritetbl
	str r0,[r1],#4				;@ Z80_memwritetbl
	str r0,[r1],#4				;@ Z80_memwritetbl
	str r0,[r1],#4				;@ Z80_memwritetbl
	str r0,[r1],#4				;@ Z80_memwritetbl


	ldr r2,=RDMEMTBL_
	ldr r1,=Z80_memreadtbl

	ldr r0,[r2]
	str r0,[r1],#4				;@ Z80_memwritetbl, WRITE_ROM
	str r0,[r1],#4				;@ Z80_memwritetbl
	str r0,[r1],#4				;@ Z80_memwritetbl
	str r0,[r1],#4				;@ Z80_memwritetbl
	str r0,[r1],#4				;@ Z80_memwritetbl
	str r0,[r1],#4				;@ Z80_memwritetbl
	str r0,[r1],#4				;@ Z80_memwritetbl
	str r0,[r1],#4				;@ Z80_memwritetbl
	bx lr
;@----------------------------------------------------------------------------
WRAMEnable:					;@ Internal RAM enable/disable.
;@----------------------------------------------------------------------------
	ldr r2,=WRMEMTBL_
	ldr r1,=Z80_memwritetbl

	ldrb r0,BankMap4
	tst r0,#0x10
	ldrne r0,[r2]
	ldreq r0,[r2,#3*4]
	str r0,[r1,#6*4]			;@ Z80_memwritetbl, WRITE_RAM
	ldreq r0,[r2,#4*4]
	str r0,[r1,#7*4]			;@ Z80_memwritetbl, WRITE_RAM mirror
	ldr r1,=rommap+48*4
	bne RAMDisabled

	ldrb r0,g_machine
	cmp r0,#HW_SG1000

	ldr r0,[r2,#32+3*4]			;@ MEMMAPTBL_
	sub r0,r0,#0xC000
	beq InitRamMap_SG1000
	mov r2,#2
initm0loop:
	str r0,[r1],#4				;@ rommap
	str r0,[r1],#4				;@ rommap
	str r0,[r1],#4				;@ rommap
	str r0,[r1],#4				;@ rommap
	str r0,[r1],#4				;@ rommap
	str r0,[r1],#4				;@ rommap
	str r0,[r1],#4				;@ rommap
	str r0,[r1],#4				;@ rommap
	sub r0,r0,#0x2000
	subs r2,r2,#1
	bne initm0loop
	bx lr

InitRamMap_SG1000:
	mov r2,#8
initm1loop:
	str r0,[r1],#4				;@ rommap
	str r0,[r1],#4				;@ rommap
	sub r0,r0,#0x800
	subs r2,r2,#1
	bne initm1loop
	bx lr

RAMDisabled:
	ldr r0,=DISABLEDMEM-0xC000
	mov r2,#16
initm2loop:
	str r0,[r1],#4				;@ rommap
	sub r0,r0,#0x400
	subs r2,r2,#1
	bne initm2loop
	bx lr

;@----------------------------------------------------------------------------
MapperDetect:		;@ In r0=rombase, r1=size.
					;@ Out r0=mapper, 0=Sega, 1=Codemaster, 2=Korean, 3=Korean MSX.
					;@ Adapted from Meka.
;@----------------------------------------------------------------------------
	cmp r1,#0x8000
	movle r0,#0
	bxle lr

	stmfd sp!,{r2-r8}
	mov r3,#0					;@ 0x8000
	mov r4,#0					;@ 0xA000
	mov r5,#0					;@ 0xFFFF
	mov r6,#0					;@ 0x0002
	mov r7,#0x8000				;@ compare size
	mov r8,#-1
MDloop:
	ldrb r1,[r0],#1
	cmp r1,#0x32				;@ Z80 opcode for: LD (xxxx), A
	beq MDe
MDe2:
	subs r7,r7,#1
	bne MDloop
	mov r0,#0

	add r1,r5,#1				;@ 2?
	cmp r3,r1
	movhi r0,#1
	movhi r3,r1
	cmp r4,r1
	movhi r0,#2
	movhi r4,r1
	cmp r6,r1
	movhi r0,#3

	ldmfd sp!,{r2-r8}
	bx lr

MDe:
	ldrb r1,[r0]
	ldrb r2,[r0,#1]
	orr r1,r1,r2,lsl#8
	cmp r1,#0x8000				;@ Codemaster mapper
	cmpne r1,#0x4000			;@ For Ernie Els Golf. Hopefully doesn't break anything.
	addeq r3,r3,#1
	addeq r0,r0,#2
	cmp r1,#0xA000				;@ Korean mapper
	addeq r4,r4,#1
	addeq r0,r0,#2
	cmp r1,r8,lsr#16			;@ SEGA mapper
	addeq r5,r5,#1
	addeq r0,r0,#2
	cmp r1,#0x0002				;@ Korean MSX mapper
	cmpne r1,#0x0003
	cmpne r1,#0x0001
	addeq r6,r6,#1
	addeq r0,r0,#2
	b MDe2
;@----------------------------------------------------------------------------
packState:	;@ called from ui.c.
;@int packState(u32 *statePtr), copy state to <here>, return size
;@----------------------------------------------------------------------------
	stmfd sp!,{r4-r5,z80pc,z80optbl,lr}
	ldr z80optbl,=Z80_optable

	mov r12,r0					;@ r0=where to copy state
	bl fixCpuPC_save			;@ adjust z80pc so it isn't based on rombase

	mov r0,#0					;@ r0 holds total size (return value)

	adr r4,savelst				;@ r4=list of stuff to copy
	mov r3,#(lstend-savelst)/8	;@ r3=items in list
ss1:
	ldmia r4!,{r1,r2}			;@ r1=what to copy, r2=how much to copy
	add r0,r0,r2
ss0:
	ldr r5,[r1],#4
	str r5,[r12],#4
	subs r2,r2,#4
	bne ss0
	subs r3,r3,#1
	bne ss1

	bl fixCpuPC_load

	ldmfd sp!,{r4-r5,z80pc,z80optbl,lr}
	bx lr

savelst:	.long EMU_SRAM,0x8000,EMU_RAM,0x2000,VDP_RAM,0x4080,rominfo,8,cpustate,104,gfxstate-16,80,SoundVariables,60,BankState,24
lstend:

fixCpuPC_save:
	load_lastbank r1
	ldr r2,[z80optbl,#z80_regs+6*4]	;@ Z80 PC
	sub r2,r2,r1
	str r2,[z80optbl,#z80_regs+6*4]	;@ Z80 PC
	bx lr

fixCpuPC_load:
	stmfd sp!,{r0,lr}
	ldr z80pc,[z80optbl,#z80_regs+6*4]	;@ Z80 PC
	encodePC
	str z80pc,[z80optbl,#z80_regs+6*4]	;@ Z80 PC
	ldmfd sp!,{r0,lr}
	bx lr

;@----------------------------------------------------------------------------
unpackState:	;@ called from ui.c
;@ void unpackState(u32* stateptr)	 (stateptr must be word aligned)
;@----------------------------------------------------------------------------
	stmfd sp!,{r4-r5,z80optbl,lr}
	ldr z80optbl,=Z80_optable

	mov r4,#(lstend-savelst)/8	;@ read entire state
	adr r3,savelst
ls1:
	ldmia r3!,{r1,r2}
ls0:
	ldr r5,[r0],#4
	str r5,[r1],#4
	subs r2,r2,#4
	bne ls0
	subs r4,r4,#1
	bne ls1

	ldrb r0,BankMap4
	ldr r1,biosbase
	tst r0,#0x40				;@ ROM?
	ldreq r1,cartbase
	tst r0,#0x08				;@ BIOS?
	ldrne r1,cartbase

	str r1,rombase

	bl FillROMBANKMAP
	bl reBankSwitch0_W
	bl reBankSwitch1_W
	bl reBankSwitch2_W

	bl fixCpuPC_load

	bl cleardirtytiles
	bl paletteTxAll

	ldmfd sp!,{r4-r5,z80optbl,lr}
	bx lr



;@----------------------------------------------------------------------------
//	.section itcm
;@----------------------------------------------------------------------------


;@------------------------------------------------------------------------------
reBankSwitchB_W:			;@ bankswitch BIOS
;@------------------------------------------------------------------------------
	ldrb r0,BankMap4
;@------------------------------------------------------------------------------
BankSwitchB_W:				;@ switch to BIOS
;@------------------------------------------------------------------------------
	ldr r2,biosbase
	ldr r1,g_BIOSBASE_GG
	cmp r2,r1
	beq BankSwitchB_GG_W

;@------------------------------------------------------------------------------
MemCtrl_SMS_W:
;@------------------------------------------------------------------------------
;@------------------------------------------------------------------------------
BankSwitchB_SMS_W:			;@ switch to BIOS (SMS)
;@------------------------------------------------------------------------------
;@	mov r11,r11
;@	ldrb r1,BankMap4
;@	cmp r0,r1
;@	bxeq lr
	strb r0,BankMap4
	stmfd sp!,{r0,lr}
	bl WRAMEnable
	ldmfd sp!,{r0,lr}

	ldr r1,biosbase
	tst r0,#0x40				;@ CART ROM?
	ldreq r1,cartbase
	tstne r0,#0x08				;@ BIOS?
	ldrne r1,cartbase

	ldr r0,rombase
	cmp r1,r0
	bxeq lr


	ldr r0,biosbase
	cmp r0,r1
	ldr r0,BankMap0
	streq r0,BankMap_Cart
	strne r0,BankMap_Bios
	ldreq r0,BankMap_Bios
	ldrne r0,BankMap_Cart
	str r0,BankMap0
	str r1,rombase

	ldrne r0,rommask_backup
	moveq r0,#0x7F
	str r0,rommask

	stmfd sp!,{lr}
	bl FillROMBANKMAP
	bl reBankSwitch0_W
	bl reBankSwitch1_W
	ldmfd sp!,{lr}
	b reBankSwitch2_W

;@------------------------------------------------------------------------------
BankSwitchB_GG_W:			;@ switch to BIOS for 0x0000-0x03FF
;@------------------------------------------------------------------------------
	strb r0,BankMap4
	stmfd sp!,{r0,lr}
	bl WRAMEnable
	ldmfd sp!,{r0,lr}

	tst r0,#0x08				;@ BIOS?
	ldreq r0,biosbase
	ldrne r0,rombase
	ldr r1,=rommap
	str r0,[r1]					;@ rommap
	b flush




;@------------------------------------------------------------------------------
;@						Codemasters mapper stuff
;@------------------------------------------------------------------------------
;@------------------------------------------------------------------------------
reBankSwitch0C_W:			;@ 0x0000-0x3FFF, Codemasters mapper
;@------------------------------------------------------------------------------
	ldrb r0,BankMap1
;@------------------------------------------------------------------------------
BankSwitch0C_W:				;@ 0x0000-0x3FFF
;@------------------------------------------------------------------------------
	strb r0,BankMap1
	and r0,r0,#0x7F
	ldrb r1,BankMap4
	tst r1,#0x08
	ldreq r1,biosbase
	ldrne r1,=ROMBANKMAP
	ldrne r1,[r1,r0,lsl#3]
	ldr r2,=rommap
	str r1,[r2],#4				;@ rommap
	ldr r1,=ROMBANKMAP
	ldr r0,[r1,r0,lsl#3]
	b Map15k
;@------------------------------------------------------------------------------
reBankSwitch1C_W:			;@ 0x4000-0x7FFF, Codemasters mapper
;@------------------------------------------------------------------------------
	ldrb r0,BankMap2
;@------------------------------------------------------------------------------
BankSwitch1C_W:				;@ 0x4000-0x7FFF
;@------------------------------------------------------------------------------
	stmfd sp!,{lr}
	bl BankSwitch1_W
	ldmfd sp!,{lr}
;@------------------------------------------------------------------------------
reBankSwitch2C_W:			;@ 0x8000-0xBFFF
;@------------------------------------------------------------------------------
	ldrb r0,BankMap3
;@------------------------------------------------------------------------------
BankSwitch2C_W:				;@ 0x8000-0xBFFF
;@------------------------------------------------------------------------------
	strb r0,BankMap3
	ldrb r1,BankMap2
	tst r1,#0x80
	beq BankSwitch2_W			;@ Normal Mapping.

	and r0,r0,#0x7F
	ldr r1,=ROMBANKMAP
	ldr r0,[r1,r0,lsl#3]
	sub r0,r0,#0x8000
	ldr r2,=rommap+32*4
	stmfd sp!,{lr}
	mov r1,r0
	bl Map8k					;@ Only map Rom to 0x8000-0x9FFF
	ldmfd sp!,{lr}


	ldr r2,=MEMMAPTBL_
	ldr r0,[r2,#20]!
	ldr r1,[r2,#-8*4]			;@ WRMEMTBL_
	ldr r2,=Z80_memwritetbl+16
	str r1,[r2,#4]				;@ Z80_memwritetbl
	ldr r2,=rommap+40*4
	mov r1,r0
	b Map8k						;@ Only map RAM to 0xA000-0xBFFF

;@------------------------------------------------------------------------------
BankSwitch0MSX_W:			;@ 0x4000-0x5FFF
;@------------------------------------------------------------------------------
	and r0,r0,#0xFF
	ldr r1,=ROMBANKMAP
	ldr r0,[r1,r0,lsl#2]
	sub r0,r0,#0x4000
	ldr r2,=rommap+16*4
	mov r1,r0
	b Map8k						;@ Only map Rom to 0x4000-0x5FFF
;@------------------------------------------------------------------------------
BankSwitch1MSX_W:			;@ 0x6000-0x7FFF
;@------------------------------------------------------------------------------
	and r0,r0,#0xFF
	ldr r1,=ROMBANKMAP
	ldr r0,[r1,r0,lsl#2]
	sub r0,r0,#0x6000
	ldr r2,=rommap+24*4
	mov r1,r0
	b Map8k						;@ Only map Rom to 0x6000-0x7FFF
;@------------------------------------------------------------------------------
BankSwitch2MSX_W:			;@ 0x8000-0x9FFF
;@------------------------------------------------------------------------------
	and r0,r0,#0xFF
	ldr r1,=ROMBANKMAP
	ldr r0,[r1,r0,lsl#2]
	sub r0,r0,#0x8000
	ldr r2,=rommap+32*4
	mov r1,r0
	b Map8k						;@ Only map Rom to 0x8000-0x9FFF
;@------------------------------------------------------------------------------
BankSwitch3MSX_W:			;@ 0xA000-0xBFFF
;@------------------------------------------------------------------------------
	and r0,r0,#0xFF
	ldr r1,=ROMBANKMAP
	ldr r0,[r1,r0,lsl#2]
	sub r0,r0,#0xA000
	ldr r2,=rommap+40*4
	mov r1,r0
	b Map8k						;@ Only map Rom to 0xA000-0xBFFF

;@----------------------------------------------------------------------------
;@----------------------------------------------------------------------------
reBankSwitch0_W:			;@ 0x0000-0x3FFF
;@----------------------------------------------------------------------------
	ldrb r0,BankMap1
;@----------------------------------------------------------------------------
BankSwitch0_W:				;@ 0x0000-0x3FFF
;@----------------------------------------------------------------------------
	strb r0,BankMap1
	ldrb r1,BankMap4
	tst r1,#0x08
	and r0,r0,#0x7F
	ldr r1,=ROMBANKMAP
	ldr r0,[r1,r0,lsl#3]
	ldreq r1,biosbase
	ldrne r1,[r1]
	ldr r2,=rommap
	str r1,[r2],#4				;@ rommap
	b Map15k

;@----------------------------------------------------------------------------
reBankSwitch1_W:			;@ 0x4000-0x7FFF
;@----------------------------------------------------------------------------
	ldrb r0,BankMap2
;@----------------------------------------------------------------------------
BankSwitch1_W:				;@ 0x4000-0x7FFF
;@----------------------------------------------------------------------------
	strb r0,BankMap2
	and r0,r0,#0x7F
	ldr r1,=ROMBANKMAP
	ldr r0,[r1,r0,lsl#3]
	sub r0,r0,#0x4000
	ldr r2,=rommap+16*4
	b Map16k

;@----------------------------------------------------------------------------
reBankSwitchR_W:			;@ 0x8000-0xBFFF
;@----------------------------------------------------------------------------
	ldrb r0,BankMap0
;@----------------------------------------------------------------------------
BankSwitchR_W:				;@ switch between ROM & RAM for 0x8000
;@----------------------------------------------------------------------------
	strb r0,BankMap0
	tst r0,#0x08				;@ RAM or ROM?
	beq reBankSwitch2_W

	and r0,r0,#0x04				;@ Bank 0/1?

	ldr r2,=MEMMAPTBL_+20
	ldr r0,[r2,r0]!
	ldr r1,[r2,#-8*4]			;@ WRMEMTBL_
	b doBank2
;@----------------------------------------------------------------------------
reBankSwitch2_W:			;@ 0x8000-0xBFFF
;@----------------------------------------------------------------------------
	ldrb r0,BankMap3
;@----------------------------------------------------------------------------
BankSwitch2_W:				;@ 0x8000-0xBFFF
;@----------------------------------------------------------------------------
	strb r0,BankMap3
	ldrb r1,BankMap0
	tst r1,#8					;@ RAM or ROM?
	bne reBankSwitchR_W

	and r0,r0,#0x7F
	ldr r1,=ROMBANKMAP
	ldr r0,[r1,r0,lsl#3]
	sub r0,r0,#0x8000
	ldr r1,=WRMEMTBL_
	ldr r1,[r1]
doBank2:
	ldr r2,=Z80_memwritetbl+16
	str r1,[r2],#4				;@ Z80_memwritetbl
	str r1,[r2],#4				;@ Z80_memwritetbl
	ldr r2,=rommap+32*4
Map16k:
	str r0,[r2],#4				;@ rommap
Map15k:
	str r0,[r2],#4				;@ rommap
	mov r1,r0
	stmia r2!,{r0-r1}			;@ rommap
	stmia r2!,{r0-r1}			;@ rommap
	stmia r2!,{r0-r1}			;@ rommap
Map8k:
	stmia r2!,{r0-r1}			;@ rommap
	stmia r2!,{r0-r1}			;@ rommap
	stmia r2!,{r0-r1}			;@ rommap
	stmia r2!,{r0-r1}			;@ rommap

;@----------------------------------------------------------------------------
flush:						;@ update cpu_pc & lastbank
;@----------------------------------------------------------------------------
	stmfd sp!,{lr}
	reencodePC
	ldmfd sp!,{lr}
	bx lr
;@----------------------------------------------------------------------------


;@----------------------------------------------------------------------------

rombase:	.long 0
biosbase:	.long 0
cardbase:	.long 0
cartbase:	.long 0
expbase:	.long 0
g_BIOSBASE_US:
	.long 0						;@ biosbase_sms, SMS
g_BIOSBASE_JP:
	.long 0						;@ biosbase_sms, SMS
g_BIOSBASE_GG:
	.long 0						;@ biosbase_gg, GG
g_ROM_Size:
	.long 0
rommask:	.long 0
rommask_backup:	.long 0

romnum:
	.long 0						;@ romnumber
rominfo:						;@ keep emuflags/BGmirror together for savestate/loadstate
g_emuflags:
	.byte 0						;@ emuflags      (label this so UI.C can take a peek) see equates.h for bitfields
//scaling:
	.byte SCALED_FIT			;@ (display type)
	.byte 0,0					;@ (sprite follow val)
g_scaling_set:
	.byte 0						;@ scalemode(saved display type)
g_cartflags:
	.byte 0 					;@ cartflags
g_machine:
	.byte 0
g_machine_set:
	.byte 0
g_config:
	.byte 0						;@ config, bit 7=BIOS on/off, bit 6=R as Start, bit 5=Select as Reset
g_config_set:
	.byte 0x00
g_region:
	.byte 0						;@ 0=Auto, 1=USA, 2=Euro, 3=Japan.
	.byte 0						;@ align
BankState:
BankMap_Exp:
	.long 0
BankMap_Card:
	.long 0
BankMap_Cart:
	.long 0
BankMap_Bios:
	.long 0
BankMap0:	.byte 0
BankMap1:	.byte 0
BankMap2:	.byte 0
BankMap3:	.byte 0
BankMap4:	.byte 0
	.byte 0,0,0		;@ alignment.

	.pool
	.section .bss
EMU_RAM:
	.space 0x2000
WRAP_RAM:						;@ Fix for "Aerial Assault [v0].gg" which jump to $FFFx and then goes from $FFFF to $0000
	.space 8
EMU_SRAM:
	.space 0x8000
DISABLEDMEM:
	.space 0x400
WRMEMTBL_:
	.space 8*4
MEMMAPTBL_:
	.space 8*4
RDMEMTBL_:
	.space 8*4
ROMBANKMAP:
	.space 256*4
ROM_Space:
	.space 0x100000
BIOS_US_Space:
	.space 0x40000				;@ US/EU 256kB BIOS max
BIOS_JP_Space:
	.space 0x2000				;@ JP 8kB BIOS max
BIOS_GG_Space:
	.space 0x400				;@ GG 1kB BIOS max

;@----------------------------------------------------------------------------


