#include "nds_asm.h"
#include "equates.h"
#include "armsdtmac.h"
#include "ARMZ80/z80mac.h"
#define CYCLE_PSL (228*CYCLE)
	.arm
	.align 4
	.section .text

	.global CPU_reset
	.global ntsc_pal_reset
	.global run
	.global scanlinehook
	.global default_scanlinehook
	.global waitMaskIn
	.global waitMaskOut
	.global sprcollision


;@----------------------------------------------------------------------------
run:		;@ return after 1 frame
;@----------------------------------------------------------------------------

	ldrb r0,waitCountIn
	add r0,r0,#1
	strb r0,waitCountIn
	ldrb r1,waitMaskIn
	ands r0,r0,r1
	ands r0,r0,#0
	bxne lr
	stmfd sp!,{r4-r11,lr}
	bl Transfer_VRAM

	ldr z80optbl,=Z80_optable
	b run_start
;@----------------------------------------------------------------------------
;@cycles ran out
;@----------------------------------------------------------------------------
line0:
	add r2,z80optbl,#z80_regs
	stmia r2,{z80f-z80pc,z80sp}	;@ save Z80 state

	ldrb r0,waitCountOut
	add r0,r0,#1
	strb r0,waitCountOut
	ldrb r1,waitMaskOut
	ands r0,r0,r1
	ldmeqfd sp!,{r4-r11,lr}		;@ exit here if doing single frame:
	bxeq lr						;@ return to rommenu()

run_start:
	adr lr,line0x				;@ return here after doing L/R + SEL/START
	ldr r0,=EMUinput
	ldr r0,[r0]

	ldr r2,=ystart
	ldrb r1,[r2]
	tst r0,#0x200				;@ L?
	subnes r1,#1
	movmi r1,#0
	tst r0,#0x100				;@ R?
	addne r1,#1
	cmp r1,#224-192
	movpl r1,#224-192
@	strb r1,[r2]

line0x:
	bl refreshEMUjoypads		;@ Z=1 if communication ok
;@	bne waitformulti			;@ waiting on other NDS..

	bl newframe					;@ display update

	adr_ r0,z80_regs
	ldmia r0,{z80f-z80pc,z80sp}	;@ restore Z80 state

	adr r0,line0_to_96
	str_ r0,z80_nexttimeout
	str_ r0,z80_nexttimeout_
	adr r0,default_scanlinehook
	str r0,scanlinehook

;@	mov r11,r11					;@ No$GBA breakpoint.
line0_to_96: ;@------------------------
	ldr r0,=scanline
	ldr r1,[r0]
	add r1,r1,#1
	str r1,[r0]

	ldr r0,=scrstartline		;@ GG screen starts later than SMS screen
	ldrb r0,[r0]				;@ GG screen starts later than SMS screen
	cmp r1,r0
	bleq earlyframe				;@ display update

	cmp r1,#30					;@ hack for Excelent Dizzy's status bar.
	ldreq addy,=vdpstat
	ldreqb r0,[addy]
	ldreq r2,=sprcollision
	ldreqb r2,[r2]
	orreq r0,r0,r2
	streqb r0,[addy]

	cmp r1,#96
	ldrmi pc,scanlinehook
;@--------------------------------------------- on line 96
	bl midframe					;@ display update

	adr addy,line96_to_VBL
	str_ addy,z80_nexttimeout
	str_ addy,z80_nexttimeout_
	ldr pc,scanlinehook
line96_to_VBL:	;@------------------------
	ldr r0,=scanline
	ldr r1,[r0]
	add r1,r1,#1
	str r1,[r0]

	ldr r0,=endframeline
	ldr r0,[r0]
	cmp r1,r0
	bleq endframe				;@ display update, r1 is saved.

	ldr r0,=vblline
	ldr r0,[r0]
	cmp r1,r0
	ldrmi pc,scanlinehook
#define vint_offset 11
	eatcycles vint_offset		;@ VBlank is 1 cycle before HBlank
	ldr addy,=hcountbp
	ldrb r0,[addy]
	sub r0,r0,#vint_offset-1
	ldr addy,=hcountoffset		;@ HC Latch need to be tweaked for this scanline.
	strb r0,[addy]
	adr addy,lineVBL
	str_ addy,z80_nexttimeout
	str_ addy,z80_nexttimeout_
	ldr pc,scanlinehook
lineVBL:	;@------------------------

	ldr addy,=FPSValue
	ldr r0,[addy]
	add r0,r0,#1
	str r0,[addy]
;@----------------------------------------

	ldr addy,=vdpstat
	ldrb r0,[addy]
	orr r0,r0,#0x80				;@ VBlank bit
	strb r0,[addy]

	add cycles,cycles,#(vint_offset-1)*CYCLE
	ldr addy,=hcountbp
	ldrb r0,[addy]
	sub r0,r0,#(vint_offset-2)
	ldr addy,=hcountoffset		;@ HC Latch need to be reset for the rest of the scanlines.
	strb r0,[addy]

	adr addy,VBL_Hook
	str_ addy,z80_nexttimeout
	str_ addy,z80_nexttimeout_
	b Z80_GO

VBL_Hook:
	ldr addy,=hcountbp
	ldrb r0,[addy]
	add r0,r0,#1
	ldr addy,=hcountoffset		;@ HC Latch need to be reset for the rest of the scanlines.
	strb r0,[addy]
	add cycles,cycles,#1*CYCLE

	ldr r0,=scanline
	ldr r1,[r0]
	add r1,r1,#1
	str r1,[r0]

	bl Check_VDP_IRQ

	adr addy,lineVBL_to_end
	str_ addy,z80_nexttimeout
	str_ addy,z80_nexttimeout_
	ldr pc,scanlinehook

lineVBL_to_end:	;@------------------------
	ldr r0,=scanline
	ldr r1,[r0]
	add r1,r1,#1
	str r1,[r0]

	ldr r2,=lastscanline
	ldr r2,[r2]
	cmp r1,r2
	bmi border_scanlinehook

	cmp cycles,#-1<<CYC_SHIFT	;@ NMI should be delayed by 1 cycle compared to HBlank.
	adrpl addy,linelast
	strpl_ addy,z80_nexttimeout
	strpl_ addy,z80_nexttimeout_
	ldrplb r0,[z80pc],#1
	ldrpl pc,[z80optbl,r0,lsl#2]
linelast:
	adr addy,line0
	str_ addy,z80_nexttimeout
	str_ addy,z80_nexttimeout_
	ldr addy,=frametotal
	ldr r1,[addy]
	add r1,r1,#1
	str r1,[addy]

	ldr r0,=g_emuflags
	ldrb r0,[r0]
	tst r0,#GG_MODE|SGAC_MODE
	bne border_scanlinehook		;@ Only pause on SMS
	add cycles,cycles,#CYCLE_PSL
	ldr r0,=joy0state
	ldrh r0,[r0]
	orr r0,r0,r0,lsr#8
	and r0,r0,#0x80				;@ SMS PAUSE?
	strb r0,[z80optbl,#z80_nmi_pin]
	b Z80_checkNMI

default_scanlinehook:
;@----------------------------------------------------------------------------
checkScanlineIRQ:
	ldr addy,=lineirq
	ldr r0,[addy]
	subs r0,r0,#1
	bpl nolineirq
	mov r0,#0x40				;@ scanline bit
	ldr r2,=vdppending
	strb r0,[r2]
	bl Check_VDP_IRQ
	ldr r2,=vdpcounter
	ldrb r0,[r2]
nolineirq:
	str r0,[addy]
border_scanlinehook:
	add cycles,cycles,#CYCLE_PSL
	b Z80_checkIRQ
;@----------------------------------------------------------------------------
scanlinehook:		.long 0
waitCountIn:		.byte 0
waitCountOut:		.byte 0
waitMaskIn:			.byte 1
waitMaskOut:		.byte 0
sprcollision:		.byte 0
					.byte 0,0,0

;@----------------------------------------------------------------------------
ntsc_pal_reset:
;@--- PAL Speed - 3546893Hz / 50Hz / 313 = 226.638
;@---NTSC Speed - 3579545Hz / 60Hz / 262 = 227.706
	ldr r0,=g_emuflags
	ldr r0,[r0]
	tst r0,#PALTIMING
;@	moveq r1,#228*CYCLE			;@ NTSC 228
;@	movne r1,#228*CYCLE			;@ PAL 228
;@	str r1,cyclesperscanline
	ldreq r0,=261				;@ NTSC
	ldrne r0,=312				;@ PAL
	ldr r1,=lastscanline
	str r0,[r1]
	bx lr
;@----------------------------------------------------------------------------
CPU_reset:		;@ called by loadcart/resetGame
;@----------------------------------------------------------------------------
	str lr,[sp,#-4]!

	ldr r1,=g_machine
	ldrb r1,[r1]
	mov r0,#0					;@ SMS
	cmp r1,#HW_MD
	moveq r0,#1					;@ MD
	cmp r1,#HW_GG
	moveq r0,#2					;@ GG
	bl Z80_reset
	bl ntsc_pal_reset
	ldr lr,[sp],#4
	bx lr

;@----------------------------------------------------------------------------


