#ifndef FILEHANDLING_HEADER
#define FILEHANDLING_HEADER

void initFileHandling(void);
int loadSettings(void);
void saveSettings(void);
int loadROM(void* dest, const char* fName, const int maxSize);
int loadBIOS(void* dest, const char* fPath, const int maxSize);
void loadState(void);
void saveState(void);
int findFolder(const char * folderName);
void selectSMSGame(void);
void selectUSBios(void);
void selectJPBios(void);
void selectGGBios(void);
int loadUSBIOS(void);
int loadJPBIOS(void);
int loadGGBIOS(void);

/// dirtable = buffer to fill.
/// dirName = name of directory to scan.
/// fileTypes = all accepted filetypes, including dots, eg. ".txt.doc.bat".
int getDirectory(char * dirTable, const char * dirName, const char * fileTypes);

/// dirtable = buffer to sort.
/// count = number of entries to sort.
void sortDirectory(char * dirTable, int count);

void getFileExtension(char * dest, const char * fileName);

const char * browseForFileType(const char * fileTypes);
void flushDirectoryCache(void);


#endif