#include "nds_asm.h"
#include "equates.h"
#include "ARMZ80/z80mac.h"
#include "armsdtmac.h"

	.global antWars
	.global GFX_init
	.global GFX_reset
	.global SetupScaling
	.global SetVDPMode
	.global debug_
	.global AGBinput
	.global EMUinput
	.global paletteInit
	.global paletteTxAll
	.global Transfer_VRAM
	.global cleardirtytiles
	.global convertPalette
	.global makeborder
	.global scanlinebp_reset
	.global HCounter_Latch
	.global newframe
	.global earlyframe
	.global midframe
	.global endframe
	.global gfxstate
	.global g_gammavalue
//	.global oambufferready
	.global g_twitch
	.global g_flicker
	.global g_gfxmask
	.global fpsenabled
	.global FPSValue
	.global vblirqhandler
	.global irqControl
	.global irqPending
	.global vdppending
	.global lineirq
	.global vdpcounter
	.global vdpstat
	.global ystart
	.global SPRS
	.global bcolor
	.global scrstartline
	.global endframeline
	.global vblline
	.global frametotal
	.global scanline
	.global lastscanline
	.global sprBank
	.global hcountoffset
	.global hcountbp

	.global VDPctrl_W
	.global VDPctrl_MD_W
	.global VDPdata_W
	.global VRAM_MD_W
	.global VDPdata_R
	.global VCounter_R
	.global HCounter_R
	.global VDPstat_R
	.global Check_VDP_IRQ

	.global VDP_RAM
	.global OAM_BUFFER1			;@ sprite scale setup should be moved here!!!

	.arm
	.align 4
	.section .text

	.global rawfont
rawfont:
	.incbin "font2.bin"

//	.global rawfontpal
//rawfontpal:
//	.incbin "fontpal.bin"

antSeed:
	.long 0x8000
;@----------------------------------------------------------------------------
antWars:
;@----------------------------------------------------------------------------
	stmfd sp!,{r4,lr}

	mov r0,#0x00
	ldr r1,=g_gfxmask
	strb r0,[r1]
	mov r0,#0x40
	ldr r1,=vdpmode2_bak2
	strb r0,[r1]

	ldr r0,=EMUPALBUFF			;@ Setup palette for antWars.
	ldr r1,=0x7FFF
	strh r1,[r0,#0x1E]

	bl SetBGOffsetsNormal

	ldr r3,=BGoffset1
	ldr r4,[r3],#4
	mov r0,#BG_GFX
	add r4,r0,r4,lsl#3
	mov r0,#0
tmLoop:
	add r1,r0,#8
	strh r1,[r4],#2
	add r0,r0,#1
	cmp r0,#1024
	bne tmLoop

	mov r0,r4
	mov r1,#0
	mov r2,#0x800/4
	bl memset_					;@ BG2 clear

	ldr r0,=BG_GFX+0x04100
	ldr r3,antSeed
	ldr r1,=0x1E31
antLoop0:
	mov r2,#8
	mov r4,#0
antLoop1:
	movs r3,r3,lsr#1
	eorcs r3,r3,#0x90000
	mov r4,r4,lsl#4
	orrcs r4,r4,#0xF
	subs r2,r2,#1
	bne antLoop1
	str r4,[r0],#4
	subs r1,r1,#1
	bne antLoop0

	str r3,antSeed
	ldmfd sp!,{r4,lr}
	bx lr
;@----------------------------------------------------------------------------
GFX_init:					;@ (called from main.c) only need to call once
;@----------------------------------------------------------------------------
	mov addy,lr

	ldr r0,=BG_GFX+0x4000
	mov r1,#0
	mov r2,#0x4000
	bl memset_					;@ clear GBA VRAM
	add r0,r0,#0x80
	ldr r1,=0x20202020
	mov r2,#0x10
	bl memset_					;@ BGR color 0
	add r0,r0,#0x40
	ldr r1,=0x30303030
	mov r2,#0x10
	bl memset_					;@ BGR color 1

	mov r1,#0xffffff00			;@ build chr decode tbl
	ldr r2,=CHR_DECODE			;@ 0x400
ppi:
	mov r0,#0
	tst r1,#0x01
	orrne r0,r0,#0x10000000
	tst r1,#0x02
	orrne r0,r0,#0x01000000
	tst r1,#0x04
	orrne r0,r0,#0x00100000
	tst r1,#0x08
	orrne r0,r0,#0x00010000
	tst r1,#0x10
	orrne r0,r0,#0x00001000
	tst r1,#0x20
	orrne r0,r0,#0x00000100
	tst r1,#0x40
	orrne r0,r0,#0x00000010
	tst r1,#0x80
	orrne r0,r0,#0x00000001
	str r0,[r2],#4
	adds r1,r1,#1
	bne ppi

	bx addy
;@----------------------------------------------------------------------------
GFX_reset:					;@ called with CPU reset
;@----------------------------------------------------------------------------
	stmfd sp!,{r0,lr}

	ldr r0,=gfxstate
	mov r1,#0
	mov r2,#16					;@ 16*4
	bl memset_					;@ clear GFX regs

	ldr r0,=wtop
	str r1,[r0]
	ldr r0,=ystart
	strb r1,[r0]

	mov r1,#0x16
	bl VDPreg00_W
	mov r1,#0xA0
	bl VDPreg01_W
	mov r1,#0xFF
	bl VDPreg02_W				;@ nametable
	mov r1,#0xFF
	bl VDPreg03_W				;@ colortable
	mov r1,#0xFF
	bl VDPreg04_W				;@ patterntable
	mov r1,#0xFF
	bl VDPreg0A_W				;@ IRQ counter

	bl SetBGOffsetsNormal

	ldr r0,=VDP_RAM
	mov r0,r0,ror#14
	ldr r1,=vramaddr
	str r0,[r1]

	bl cleardirtytiles
	bl cleartilemaps


	mov r0,#OAM
	mov r1,#0x2C0
	mov r2,#0x100
	bl memset_					;@ no stray sprites please
	ldr r0,=OAM_BUFFER1
	mov r2,#0x200
	bl memset_

	bl MapSG_Pal
	ldmfd sp!,{r0}
	cmp r0,#0
	bleq FillPalette			;@ Don't clear palette when loading a savestate.
	bl paletteInit				;@ do palette mapping
	bl paletteTxAll				;@ transfer it

	bl makeborder
	bl scanlinebp_reset
	bl MakeVDPModes
	bl SetupVDPType
	bl SetupScaling

	ldmfd sp!,{pc}

;@----------------------------------------------------------------------------
SetBGOffsetsNormal:
;@----------------------------------------------------------------------------
	ldr r1,=BGoffset1
	mov r0,#0x0000
	str r0,[r1],#4
	mov r0,#0x0900
	str r0,[r1],#4
	mov r0,#0x0C00
	str r0,[r1],#4
	bx lr
;@----------------------------------------------------------------------------
SetBGOffsetsMode2:
;@----------------------------------------------------------------------------
	ldr r1,=BGoffset1
	mov r0,#0x0000
	str r0,[r1],#4
	str r0,[r1],#4
	str r0,[r1],#4
	bx lr
;@----------------------------------------------------------------------------
cleardirtytiles:
;@----------------------------------------------------------------------------
	ldr r0,=DIRTYTILES
	mov r1,#0		
	mov r2,#0x200/4
	b memset_
;@----------------------------------------------------------------------------
cleartilemaps:
;@----------------------------------------------------------------------------
	stmfd sp!,{r4-r6,lr}
	ldr r3,=BGoffset1
	mov r6,#3
clrtmLoop2:
	ldr r4,[r3],#4
	mov r0,#BG_GFX
	add r4,r0,r4,lsl#3
	mov r5,#3
clrtmLoop1:
	add r0,r4,#0x700
	add r4,r4,#0x800
	mov r1,#0		
	mov r2,#0x100/4
	bl memset_
	subs r5,r5,#1
	bne clrtmLoop1
	subs r6,r6,#1
	bne clrtmLoop2
	ldmfd sp!,{r4-r6,pc}
;@----------------------------------------------------------------------------
scanlinebp_reset:
;@----------------------------------------------------------------------------
	ldr r0,=g_emuflags
	ldr r0,[r0]
	tst r0,#PALTIMING

	moveq r0,#0xDA			;@ NTSC
	moveq r1,#6				;@ 262
	movne r0,#0xF2			;@ PAL
	movne r1,#0x39			;@ 313

	ldr r2,=scanlinebp
	str r0,[r2]
	ldr r2,=scanlineminus
	strb r1,[r2]

	bx lr
;@----------------------------------------------------------------------------
makeborder:					;@ also called from UI.c, r0 = border type.
;@----------------------------------------------------------------------------

	mov r1,#0x00C0				;@ H start-end
	mov r2,#0x08C0				;@ H start-end
	mov r12,#0xC000				;@ H start-end Win1

	ldr r0,=g_machine
	ldrb r0,[r0]
	cmp r0,#HW_GG

	moveq r1,#0x08C0			;@ H start-end
	ldreq r12,=0xC0F8			;@ H start-end Win1

	ldr r0,=g_emuflags
	ldrb r0,[r0]
	tst r0,#GG_MODE

	ldrne r1,=0x30C0			;@ H start-end
	ldrne r2,=0x30C0			;@ H start-end
	ldrne r12,=0xC0D0			;@ H start-end Win1

	str r1,Window0HValue_normal
	str r2,Window0HValue_col0
	str r12,Window1HValue
	
	mov r1,#REG_BASE
	mov r0,#0x0000
	strh r0,[r1,#REG_WINOUT]

	bx lr
;@----------------------------------------------------------------------------
MakeVDPModes:
;@----------------------------------------------------------------------------
	adr r1,VDPModes_SMS2		;@ For SMS2 & GG.
	ldr r0,=g_machine
	ldrb r0,[r0]
	cmp r0,#HW_SG1000
	adreq r1,VDPModes_SG1000
	cmp r0,#HW_SMS1
	adreq r1,VDPModes_SMS1
	cmp r0,#HW_MD
	adreq r1,VDPModes_MD

	adr r0,VDPModes
	mov r2,#32
	b bytecopy_

VDPModes_SG1000:
	.byte VDPMODE_0,VDPMODE_0,VDPMODE_3,VDPMODE_3,VDPMODE_1,VDPMODE_1,VDPMODE_B,VDPMODE_B
	.byte VDPMODE_2,VDPMODE_2,VDPMODE_B,VDPMODE_B,VDPMODE_B,VDPMODE_B,VDPMODE_B,VDPMODE_B
	.byte VDPMODE_0,VDPMODE_0,VDPMODE_3,VDPMODE_3,VDPMODE_1,VDPMODE_1,VDPMODE_B,VDPMODE_B
	.byte VDPMODE_2,VDPMODE_2,VDPMODE_B,VDPMODE_B,VDPMODE_B,VDPMODE_B,VDPMODE_B,VDPMODE_B
VDPModes_SMS1:
	.byte VDPMODE_0,VDPMODE_0,VDPMODE_3,VDPMODE_3,VDPMODE_1,VDPMODE_1,VDPMODE_B,VDPMODE_B
	.byte VDPMODE_2,VDPMODE_2,VDPMODE_B,VDPMODE_B,VDPMODE_B,VDPMODE_B,VDPMODE_B,VDPMODE_B
	.byte VDPMODE_4,VDPMODE_4,VDPMODE_4,VDPMODE_4,VDPMODE_B,VDPMODE_B,VDPMODE_B,VDPMODE_B
	.byte VDPMODE_4,VDPMODE_4,VDPMODE_4,VDPMODE_4,VDPMODE_B,VDPMODE_B,VDPMODE_B,VDPMODE_B
VDPModes_SMS2:
	.byte VDPMODE_0,VDPMODE_0,VDPMODE_3,    VDPMODE_3,    VDPMODE_1,    VDPMODE_1,    VDPMODE_B,VDPMODE_B
	.byte VDPMODE_2,VDPMODE_2,VDPMODE_B,    VDPMODE_B,    VDPMODE_B,    VDPMODE_B,    VDPMODE_B,VDPMODE_B
	.byte VDPMODE_4,VDPMODE_4,VDPMODE_4,    VDPMODE_4,    VDPMODE_B,    VDPMODE_B,    VDPMODE_B,VDPMODE_B
	.byte VDPMODE_4,VDPMODE_4,VDPMODE_4_240,VDPMODE_4_240,VDPMODE_4_224,VDPMODE_4_224,VDPMODE_4,VDPMODE_4
VDPModes_MD:
	.byte VDPMODE_B,VDPMODE_5_224,VDPMODE_B,VDPMODE_5_224,VDPMODE_B,VDPMODE_5_224,VDPMODE_B,VDPMODE_5_224
	.byte VDPMODE_B,VDPMODE_5_240,VDPMODE_B,VDPMODE_5_240,VDPMODE_B,VDPMODE_5_240,VDPMODE_B,VDPMODE_5_240
	.byte VDPMODE_4,VDPMODE_5_224,VDPMODE_4,VDPMODE_5_224,VDPMODE_4,VDPMODE_5_224,VDPMODE_4,VDPMODE_5_224
	.byte VDPMODE_4,VDPMODE_5_240,VDPMODE_4,VDPMODE_5_240,VDPMODE_4,VDPMODE_5_240,VDPMODE_4,VDPMODE_5_240
VDPModes:
	.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

;@(M4)
;@(M2)
;@(M1)
;@(M3)
;@(M5)
;@----------------------------------------------------------------------------
SetupVDPType:
;@----------------------------------------------------------------------------
	ldr r0,=g_machine
	ldrb r0,[r0]
	cmp r0,#HW_SG1000
	ldreq r1,=VDPctrl2_W
	ldrne r1,=VDPctrl3_W
	ldr r2,=VDPdest
	str r1,[r2,#0x0C]

	ldreq r1,VDPRegMask_SG1000
	ldrne r1,VDPRegMask_SMS
	cmp r0,#HW_MD
	ldreq r1,VDPRegMask_MD
	ldr r2,=VDPRegMask
	str r1,[r2]

	ldrne r1,=VDPreg01_W
	ldreq r1,=VDPreg01_MD_W
	ldr r2,=VDPregs_jmp_table+4
	str r1,[r2]

	ldr r1,=VRAM_W				;@ setup correct destination for VDP data writes.
	ldreq r1,=VRAM_MD_W
	ldr r2,=VDPMemDest
	str r1,[r2]
	str r1,[r2,#4]
	ldreq r1,=CRAM_MD_W
	str r1,[r2,#8]
	str r1,[r2,#12]
	mov r1,#-1					;@ Should be randomized?
	moveq r1,#0x13				;@ Startup scanline on MegaDrive.
	ldr addy,=scanline
	str r1,[addy]
	mov r1,#11					;@ HCount 0xF4.
	moveq r1,#12				;@ HCount 0xF6 (second one).
	ldr addy,=vcountbp			;@ Which HCount VCount changes.
	strb r1,[addy]
	mov r1,#25
	moveq r1,#29
	ldr addy,=hcountbp			;@ Which HCount HIRQ happens.
	strb r1,[addy]
	ldr addy,=hcountoffset		;@ Offset for HC calculation.
	add r1,r1,#1
	strb r1,[addy]
	cmpne r0,#HW_SG1000
	bxeq lr

	ldr r1,=CRAM_SMS_W
	ldr r0,=g_emuflags
	ldrb r0,[r0]
	tst r0,#GG_MODE
	ldrne r1,=CRAM_GG_W
	str r1,[r2,#12]
	bx lr

VDPRegMask_SG1000:
	and r0,r1,#0x0700
VDPRegMask_SMS:
	and r0,r1,#0x0F00
VDPRegMask_MD:
	and r0,r1,#0x1F00


;@----------------------------------------------------------------------------
SetupScaling:		;@ r0-r3, r12 modified.
;@----------------------------------------------------------------------------
	adr r0,BG_SCALING_1_1
	ldr r3,=g_emuflags
	ldrb r3,[r3]
	ldr r2,=g_machine
	ldrb r2,[r2]
	ldr r1,=g_scaling_set
	ldrb r1,[r1]

	tst r3,#GG_MODE
	adrne r0,BG_SCALING_1_1_GG
	cmp r1,#SCALED_1_1
	beq LoadScaleValues

	cmp r1,#SCALED_FIT
	bne nofit
	adr r0,BG_SCALING_TO_FIT
	tst r3,#GG_MODE
	adrne r0,BG_SCALING_1_1_GG
	b LoadScaleValues
nofit:
	cmp r1,#SCALED_ASPECT
	bne LoadScaleValues

	adr r0,BG_SCALING_ASPECT_NTSC
	tst r3,#PALTIMING
	adrne r0,BG_SCALING_ASPECT_PAL
	cmp r2,#HW_GG
	adreq r0,BG_SCALING_ASPECT_GG
	tst r3,#GG_MODE
	adrne r0,BG_SCALING_ASPECT_GGMODE

LoadScaleValues:
	ldmia r0!,{r1-r3}
	adr r12,BG_SCALING_TBL
	stmia r12,{r1-r3}

	ldmia r0!,{r1-r3}
	adr r12,BG_SCALING_WIN
	stmia r12,{r1-r3}

	ldmia r0!,{r1-r3}
	adr r12,BG_SCALING_OFS
	stmia r12,{r1-r3}

	ldmia r0!,{r1-r3}
	adr r12,scalesprparam
	stmia r12,{r1-r3}
	
	b SetupSpriteScaling

BG_SCALING_TO_FIT:	;@ 1:1, 7:6, 5:4
	.long 0xFFFF,0xDB6D,0xCCCD
	.long 0x00C0,0x00C0,0x00C0
	.long 0x0000,0x0000,0x0000
	.long 0x0100,0x0100,0x0080
BG_SCALING_1_1:
	.long 0xFFFF,0xFFFF,0xFFFF
	.long 0x00C0,0x00C0,0x00C0
	.long 0x0000,0x0010,0x0018
	.long 0x0100,0x0100,0x0080
BG_SCALING_1_1_GG:
	.long 0xFFFF,0xFFFF,0xFFFF
	.long 0x18A8,0x18A8,0x18A8
	.long 0x0000,0x0010,0x0018
	.long 0x0100,0x0100,0x0080
BG_SCALING_ASPECT_PAL:			;@ 192->142, 224->165, 240->177
	.long 0xBD56,0xBD56,0xBD56
	.long 0x19A7,0x0DB2,0x00C0
	.long    -34,   -17,    -8
	.long 0x0150,0x0150,0x00AD
BG_SCALING_ASPECT_NTSC:			;@ 192->170, 224->199, 240->213, 216->192, 9->8
	.long 0xE38F,0xE2AB,0xE2AB
	.long 0x0BB5,0x00C0,0x00C0
	.long    -12,0x0004,0x000C
	.long 0x0100,0x0120,0x0090
BG_SCALING_ASPECT_GG:			;@ 192->160, 216->180, 6->5
	.long 0xD555,0xD555,0xD555
	.long 0x10B0,0x07BA,0x06BA
	.long    -19,    -3,0x0008
	.long 0x0133,0x0133,0x0092
BG_SCALING_ASPECT_GGMODE:		;@ 160x144 -> 160x120, 6->5
	.long 0xD555,0xD555,0xD555
	.long 0x249C,0x249C,0x249C
	.long    -19,    -3,0x0008
	.long 0x0133,0x0133,0x0092

BG_SCALING_TBL:
	.long 0,0,0
BG_SCALING_WIN:
	.long 0x00C0,0x00C0,0x00C0
BG_SCALING_OFS:
	.long 0,0,0

scaleparms:
	.long 0x0000				;@ rotate value
	.long 0x0100				;@ Normal
	.long 0x0080				;@ Double
scalesprparam:
	.long 0x0100				;@ Scaled Normal Vertical
	.long 0x0120				;@ Scaled 8x16 Vertical
	.long 0x0090				;@ Scaled Double Vertical
	.long OAM_BUFFER1+6
	.long OAM+774
;@----------------------------------------------------------------------------
SetupSpriteScaling:
;@----------------------------------------------------------------------------
	stmfd sp!,{r4-r8}
	adr r6,scaleparms			;@ set sprite scaling params
	ldmia r6,{r0-r7}

	mov r8,#2
scaleloop:
	strh r1,[r6],#8				;@ buffer1, buffer2. normal sprites
	strh r0,[r6],#8
	strh r0,[r6],#8
	strh r3,[r6],#8
		strh r1,[r6],#8			;@ 8x16 sprites
		strh r0,[r6],#8
		strh r0,[r6],#8
		strh r4,[r6],#8
			strh r2,[r6],#8			;@ double sprites
			strh r0,[r6],#8
			strh r0,[r6],#8
			strh r5,[r6],#8
				strh r2,[r6],#8			;@ 8x16 double sprites
				strh r0,[r6],#8
				strh r0,[r6],#8
				strh r5,[r6],#8
	add r6,r6,#0x380
	subs r8,r8,#1
	bne scaleloop

	strh r3,[r7],#8				;@ 7000200
	strh r0,[r7],#8
	strh r0,[r7],#8
	strh r4,[r7]

	ldmfd sp!,{r4-r8}
	bx lr
;@----------------------------------------------------------------------------
paletteInit:		;@ r0-r3 modified.
;@ called by ui.c:  void map_palette();
;@----------------------------------------------------------------------------
	stmfd sp!,{r4-r9,lr}
	mov r7,#0xF					;@ mask
	ldr r6,=MAPPED_RGB
	ldrb r1,g_gammavalue			;@ gamma value = 0 -> 4
	mov r4,#4096*2
	sub r4,r4,#2
nomap:							;@ map 0000bbbbggggrrrr  ->  0bbbbbgggggrrrrr
	and r0,r7,r4,lsr#9			;@ Blue ready
	bl gprefix
	mov r5,r0

	and r0,r7,r4,lsr#5			;@ Green ready
	bl gprefix
	orr r5,r0,r5,lsl#5

	and r0,r7,r4,lsr#1			;@ Red ready
	bl gprefix
	orr r5,r0,r5,lsl#5

	strh r5,[r6,r4]
	subs r4,r4,#2
	bpl nomap
	ldmfd sp!,{r4-r9,lr}

;@----------------------------------------------------------------------------
convertPalette:				;@ r0 = destination, r1 = source, r2 = length. r3, r12 modified.
;@ called by main.c:  void convertPalette(void* destination,void* source, int length);
;@----------------------------------------------------------------------------
	stmfd sp!,{r4-r7,lr}
	mov r4,r0					;@ destination
	mov r5,r1					;@ source
	mov r6,r2					;@ length
	ldrb r1,g_gammavalue		;@ gamma value = 0 -> 4
convloop:						;@ map rrrrrrrrbbbbbbbbgggggggg  ->  0bbbbbgggggrrrrr
	ldrb r0,[r5],#1				;@ Red
	bl gammaconvert
	mov r7,r0

	ldrb r0,[r5],#1				;@ Green
	bl gammaconvert
	orr r7,r7,r0,lsl#5

	ldrb r0,[r5],#1				;@ Blue
	bl gammaconvert
	orr r7,r7,r0,lsl#10

	strh r7,[r4],#2
	subs r6,r6,#1
	bhi convloop

	ldmfd sp!,{r4-r7,lr}
	bx lr

MapSG_Pal:
	stmfd sp!,{r4-r10,lr}
	ldrb r1,g_gammavalue			;@ gamma value = 0 -> 4
	ldr r0,=g_machine_set
	ldrb r0,[r0]
	cmp r0,#HW_AUTO
	cmpne r0,#HW_SG1000
	adr r6,SG_Palette
	addne r6,r6,#0x30			;@ SMS/SMS2 uses it's own palette
	ldr r7,=EMUPALBUFF+0x80
	ldr r8,=EMUPALBUFF+0x202
	ldr r9,=BG_PALETTE+0x202
	mov r4,#16
nomapSG:						;@ map rrrrrrrrggggggggbbbbbbbb  ->  0bbbbbgggggrrrrr
	ldrb r0,[r6,#2]				;@ Blue ready
	bl gammaconvert
	mov r5,r0

	ldrb r0,[r6,#1]				;@ Green ready
	bl gammaconvert
	orr r5,r0,r5,lsl#5

	ldrb r0,[r6],#3				;@ Red ready
	bl gammaconvert
	orr r5,r0,r5,lsl#5

	strh r5,[r7],#2
	strh r5,[r8],#0x20
	strh r5,[r9],#0x20
	subs r4,r4,#1
	bne nomapSG
	ldmfd sp!,{r4-r10,lr}
	bx lr

FillPalette:
	stmfd sp!,{lr}
	ldr r0,=g_machine
	ldrb r0,[r0]
	cmp r0,#HW_MD
	adrne r1,SMS_Default_Palette
	adreq r1,MD_Default_Palette

	ldr r0,=PALETTE_RAM
	mov r2,#64
	bl bytecopy_
	bl paletteTxAll

	ldmfd sp!,{lr}
	bx lr

;@----------------------------------------------------------------------------
SG_Palette:
	.byte 0,0,0,          0,0,0,          36,218,36,      109,255,109,    36,36,255,      72,109,255,     182,36,36,      72,218,255
	.byte 255,36,36,      255,109,109,    218,218,36,     218,218,145,    36,145,36,      218,72,182,     182,182,182,    255,255,255

SG_Palette_SMS:
	.byte 0x00,0x00,0x00, 0x00,0x00,0x00, 0x00,0xAA,0x00, 0x00,0xFF,0x00, 0x00,0x00,0x55, 0x00,0x00,0xFF, 0x55,0x00,0x00, 0x00,0xFF,0xFF
	.byte 0xAA,0x00,0x00, 0xFF,0x00,0x00, 0x55,0x55,0x00, 0xFF,0xFF,0x00, 0x00,0x55,0x00, 0xFF,0x00,0xFF, 0x55,0x55,0x55, 0xFF,0xFF,0xFF

;@TMS9918 spec.
;@	.byte 0,0,0,          0,0,0,          33,200,66,      94,220,120,     84,85,237,      125,118,252,    212,82,77,      66,235,245
;@	.byte 252,85,84,      255,121,120,    212,193,84,     230,206,128,    33,176,59,      201,91,186,     204,204,204,    255,255,255

SMS_Default_Palette:
	.short 0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000
	.short 0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000
MD_Default_Palette:
	.short 0x0FFF,0x0FFF,0x0FFF,0x0FFF,0x0FFF,0x0FFF,0x0FFF,0x0FFF,0x0FFF,0x0FFF,0x0FFF,0x0FFF,0x0FFF,0x0FFF,0x0FFF,0x0FFF
	.short 0x000F,0x0005,0x0000,0x0000,0x0FFF,0x0FFF,0x0FFF,0x0FFF,0x0FFF,0x0FFF,0x0FFF,0x0FFF,0x0FFF,0x0FFF,0x0AFF,0x0FFF
;@----------------------------------------------------------------------------
gprefix:
	orr r0,r0,r0,lsl#4
;@----------------------------------------------------------------------------
gammaconvert:	;@ takes value in r0(0-0xFF), gamma in r1(0-4),returns new value in r0=0x1F
;@----------------------------------------------------------------------------
	rsb r2,r0,#0x100
	mul r3,r2,r2
	rsbs r2,r3,#0x10000
	rsb r3,r1,#4
	orr r0,r0,r0,lsl#8
	mul r2,r1,r2
	mla r0,r3,r0,r2
	mov r0,r0,lsr#13

	bx lr
;@----------------------------------------------------------------------------
paletteTxAll:				;@ Called from ui.c
;@----------------------------------------------------------------------------
	stmfd sp!,{r4,lr}
	ldr r3,=PALETTE_RAM
	mov r4,#0
txloop:
	ldrh r0,[r3],#2
	mov r1,r4
	bl Write_Pal
	add r4,r4,#1
	cmp r4,#0x20
	bmi txloop

	ldmfd sp!,{r4,lr}
	bx lr
;@----------------------------------------------------------------------------
PaletteTxGGSG:				;@ for SG modes on GG
;@----------------------------------------------------------------------------
	stmfd sp!,{r4-r5}
	ldr r2,=EMUPALBUFF+2
	add r3,r2,#0x80
	ldr r4,=EMUPALBUFF+0x202
	add r5,r4,#0x20
	mov r1,#0xf
ggsgloop:
	ldrh r0,[r2],#2
	strh r0,[r3],#2
	ldrh r0,[r4],#2
	strh r0,[r5],#0x20
	subs r1,r1,#1
	bne ggsgloop

	ldmfd sp!,{r4-r5}
	bx lr

.pool


;@----------------------------------------------------------------------------
Delay_VRAM:					;@ This is used to get rid of graphics corruption
;@----------------------------------------------------------------------------
	stmfd sp!,{r4-r11,lr}

	ldr r0,=DirtyTilesBackup
	ldr r1,=DIRTYTILES
	ldr r4,=VDP_RAM

	mov r2,#0x200
	mov r12,#-1
	sub r2,r2,#1
dvramloop0:
	ldrb r3,[r1,r2]
	cmp r3,#0
	bleq dvramcopy
	subs r2,r2,#1
	bpl dvramloop0

	ldmfd sp!,{r4-r11,lr}
	bx lr

dvramcopy:
	strb r12,[r1,r2]
	strb r3,[r0,r2]

	add r5,r4,r2,lsl#5
	add r6,r5,#0x4000
	mov r7,#0x20
dvramloop1:
	ldr r3,[r5],#4
	str r3,[r6],#4
	subs r7,r7,#1
	bpl dvramloop1
	bx lr

;@----------------------------------------------------------------------------
T_data:
//	.long DIRTYTILES
	.long DirtyTilesBackup
VDP_RAM_ptr:
//	.long VDP_RAM
	.long VDP_RAM+0x4000
	.long CHR_DECODE
	.long BG_GFX+0x05800		;@ BGR tiles mode0,1 & 2
//	.long BG_GFX+0x10000		;@ SPR tiles
	.long BG_GFX+0x400000		;@ SPR tiles
;@----------------------------------------------------------------------------
Transfer_VRAM:
;@----------------------------------------------------------------------------
	adr r0,T_data
	ldmia r0,{r4-r8}
	mov r1,#0

	ldr r0,=vdprmode
	ldrb r0,[r0]
	cmp r0,#VDPMODE_4
	beq Transfer_VRAM_m4
	cmp r0,#VDPMODE_0
	cmpne r0,#VDPMODE_1
	cmpne r0,#VDPMODE_2
	beq Transfer_VRAM_m2
	cmp r0,#VDPMODE_5
	beq Transfer_VRAM_m5
	bx lr

;@----------------------------------------------------------------------------
Transfer_VRAM_m0:
;@----------------------------------------------------------------------------
	and r2,r2,#0x07
	add r11,r5,r3,lsl#6
	add r5,r5,r2,lsl#11
	cmp r0,#VDPMODE_1
	beq	Transfer_VRAM_m1

	ldrb r9,[r4,r3,lsl#1]
	orr r0,r9,#0x0F
	strb r0,[r4,r3,lsl#1]
	orr r9,r9,r9,lsl#8
	orr r9,r9,r9,lsl#16
	add r4,r4,r2,lsl#6
tileloop0_0:
	ldr r0,=0x01010101			;@ Dirtytiles mode 0 bgr.
	ldr addy,[r4]
	orr r2,addy,r0
	str r2,[r4],#4
	and addy,addy,r9
	tst addy,#0x00000001
	addne r1,r1,#0x20
	bleq tileloop0_1
	tst addy,#0x00000100
	addne r1,r1,#0x20
	bleq tileloop0_1
	tst addy,#0x00010000
	addne r1,r1,#0x20
	bleq tileloop0_1
	tst addy,#0x01000000
	addne r1,r1,#0x20
	bleq tileloop0_1
	cmp r1,#0x0800
	bne tileloop0_0

	b tileloop_spr
;@----------------------------------------------------------------------------
Transfer_VRAM_m1:
;@----------------------------------------------------------------------------
	add r4,r4,r2,lsl#6
	ldr r10,=0x02020202			;@ Dirtytiles mode 1 bgr.
tileloop1_0:
	ldr addy,[r4]
	orr r2,addy,r10
	str r2,[r4],#4
	tst addy,#0x00000002
	addne r1,r1,#0x20
	bleq tileloop1_1
	tst addy,#0x00000200
	addne r1,r1,#0x20
	bleq tileloop1_1
	tst addy,#0x00020000
	addne r1,r1,#0x20
	bleq tileloop1_1
	tst addy,#0x02000000
	addne r1,r1,#0x20
	bleq tileloop1_1
	cmp r1,#0x0800
	bne tileloop1_0

	ldmfd sp!,{r10,r11,pc}

;@----------------------------------------------------------------------------
Transfer_VRAM_m2:
;@----------------------------------------------------------------------------
	ldr r2,=vdpmode2
	ldrb r2,[r2]
	tst r2,#0x40				;@ Screen on?
	bxeq lr
	stmfd sp!,{r10,r11,lr}
	ldr r8,=0x11111111
	ldr r3,=ctoffset
	ldrb r3,[r3]
	ldr r2,=pgoffset
	ldrb r2,[r2]
	cmp r0,#VDPMODE_0
	cmpne r0,#VDPMODE_1
	beq	Transfer_VRAM_m0
	and r3,r3,#0x80
	add r11,r5,r3,lsl#6
	add r9,r4,r3,lsl#1
	and r2,r2,#0x04
	add r5,r5,r2,lsl#11
	add r4,r4,r2,lsl#6
	ldr r10,=0x04040404			;@ Dirtytiles mode 2 bgr.

tileloop2_0:
	ldr addy,[r4]
	orr r2,addy,r10
	str r2,[r4],#4
	ldr r2,[r9]
	and addy,addy,r2
	orr r2,r2,r10
	str r2,[r9],#4
	tst addy,#0x00000004
	addne r1,r1,#0x20
	bleq tileloop2_2
	tst addy,#0x00000400
	addne r1,r1,#0x20
	bleq tileloop2_2
	tst addy,#0x00040000
	addne r1,r1,#0x20
	bleq tileloop2_2
	tst addy,#0x04000000
	addne r1,r1,#0x20
	bleq tileloop2_2
	cmp r1,#0x1800
	bne tileloop2_0

;@----------------------------------------------------------------------------
tileloop_spr:				;@ Mode0, 2 & 3 sprites.
;@----------------------------------------------------------------------------
	ldr r9,=0x10101010			;@ Dirtytiles mode 0, 2 & 3 spr.
	ldr r1,=sproffset
	ldrb r1,[r1]
	and r1,r1,#0x07
	mov r1,r1,lsl#11
	ldr r4,T_data
	ldr r5,VDP_RAM_ptr
	add r4,r4,r1,lsr#5
	add r7,r7,#0x400000			;@ Sprites @ 0x06406000
	add r7,r7,#0x800			;@ Sprites @ 0x06406000
	sub r7,r7,r1,lsl#2			;@ r1 is later added in the render loop.
	add r8,r1,#0x800
tileloop2_1:
	ldr addy,[r4]
	orr r2,addy,r9
	str r2,[r4],#4
	tst addy,#0x00000010
	addne r1,r1,#0x20
	bleq tileloop1_1
	tst addy,#0x00001000
	addne r1,r1,#0x20
	bleq tileloop1_1
	tst addy,#0x00100000
	addne r1,r1,#0x20
	bleq tileloop1_1
	tst addy,#0x10000000
	addne r1,r1,#0x20
	bleq tileloop1_1
	cmp r1,r8
	bne tileloop2_1

	ldmfd sp!,{r10,r11,pc}

;@----------------------------------------------------------------------------
;@----------------------------------------------------------------------------
tileloop0_1:
	bic r2,r1,#0x1800
	ldrb r2,[r11,r2,lsr#6]
	mov r3,r2,lsr#4
	and r2,r2,#0x0F
tileloop0_2:
	ldrb r0,[r5,r1]
	ldr r0,[r6,r0,lsl#2]
	mul r10,r0,r3
	eor r0,r0,r8
	mla r10,r0,r2,r10
	str r10,[r7,r1,lsl#2]
	add r1,r1,#1
	tst r1,#0x1F
	bne tileloop0_2
	bx lr

tileloop1_1:
	ldrb r0,[r5,r1]
	ldr r0,[r6,r0,lsl#2]
	str r0,[r7,r1,lsl#2]
	add r1,r1,#1
	tst r1,#0x1F
	bne tileloop1_1
	bx lr

tileloop2_2:
	ldrb r2,[r11,r1]
	ldrb r0,[r5,r1]
	ldr r0,[r6,r0,lsl#2]
	movs r3,r2,lsr#4
	mulne r3,r0,r3
	eor r0,r0,r8
	ands r2,r2,#0x0F
	mlane r3,r0,r2,r3
	str r3,[r7,r1,lsl#2]
	add r1,r1,#1
	tst r1,#0x1F
	bne tileloop2_2
	bx lr

;@----------------------------------------------------------------------------
Transfer_VRAM_m4:
;@----------------------------------------------------------------------------
	stmfd sp!,{lr}
	ldr r7,=BG_GFX+0x08000
	ldr r9,=0x20202020			;@ Dirtytiles mode4 bgr & spr

tileloop4_0:
	ldr addy,[r4]
	str r9,[r4],#4
	tst addy,#0x00000020
	addne r1,r1,#0x20
	bleq tileloop4_1
	tst addy,#0x00002000
	addne r1,r1,#0x20
	bleq tileloop4_1
	tst addy,#0x00200000
	addne r1,r1,#0x20
	bleq tileloop4_1
	tst addy,#0x20000000
	addne r1,r1,#0x20
	bleq tileloop4_1
	cmp r1,#0x4000
	bne tileloop4_0

	ldmfd sp!,{pc}

tileloop4_1:
	ldr r0,[r5,r1]

	ands r3,r0,#0x000000FF
	ldrne r3,[r6,r3,lsl#2]
	ands r2,r0,#0x0000FF00
	ldrne r2,[r6,r2,lsr#6]
	orrne r3,r3,r2,lsl#1
	ands r2,r0,#0x00FF0000
	ldrne r2,[r6,r2,lsr#14]
	orrne r3,r3,r2,lsl#2
	ands r2,r0,#0xFF000000
	ldrne r2,[r6,r2,lsr#22]
	orrne r3,r3,r2,lsl#3

	str r3,[r7,r1]
	str r3,[r8,r1]
	add r1,r1,#4
	tst r1,#0x1C
	bne tileloop4_1

	bx lr
;@----------------------------------------------------------------------------
Transfer_VRAM_m5:
;@----------------------------------------------------------------------------
	stmfd sp!,{lr}
	ldr r7,=BG_GFX+0x07800
	ldr r9,=0x40404040			;@ Dirtytiles mode5 bgr & spr

tileloop5_0:
	ldr addy,[r4]
	str r9,[r4],#4
	tst addy,#0x00000040
	addne r1,r1,#0x20
	bleq tileloop5_1
	tst addy,#0x00004000
	addne r1,r1,#0x20
	bleq tileloop5_1
	tst addy,#0x00400000
	addne r1,r1,#0x20
	bleq tileloop5_1
	tst addy,#0x40000000
	addne r1,r1,#0x20
	bleq tileloop5_1
	cmp r1,#0x4000
	bne tileloop5_0

	ldmfd sp!,{pc}

tileloop5_1:
	ldr r0,[r5,r1]

	str r0,[r7,r1]
	str r0,[r8,r1]
	add r1,r1,#4
	tst r1,#0x1C
	bne tileloop5_1

	bx lr
;@----------------------------------------------------------------------------
showfps_:		;@ fps output, r0-r3=used.
;@----------------------------------------------------------------------------
	ldrb r0,fpschk
	subs r0,r0,#1
	movmi r0,#59
	strb r0,fpschk
	bxpl lr						;@ End if not 60 frames has passed

	ldrb r0,fpsenabled
	tst r0,#1
	bxeq lr						;@ End if not enabled

	ldr r2,=FPSValue
	ldr r0,[r2]
	cmp r0,#0
	bxeq lr						;@ End if fps==0, to keep it from appearing in the menu
	mov r1,#0
	str r1,[r2]

	mov r1,#100
	swi 0x090000				;@ Division r0/r1, r0=result, r1=remainder.
	add r0,r0,#0x30
	strb r0,fpstext+5
	mov r0,r1
	mov r1,#10
	swi 0x090000				;@ Division r0/r1, r0=result, r1=remainder.
	add r0,r0,#0x30
	strb r0,fpstext+6
	add r1,r1,#0x30
	strb r1,fpstext+7
	

	adr r0,fpstext
	ldr r2,=DEBUGSCREEN
db1:
	ldrb r1,[r0],#1
	orr r1,r1,#0x3100
	strh r1,[r2],#2
	tst r2,#0xE
	bne db1

	bx lr
;@----------------------------------------------------------------------------
fpstext:	.string "FPS:   "
fpsenabled:	.byte 0
fpschk:		.byte 0
			.byte 0
			.byte 0
;@----------------------------------------------------------------------------
debug_:						;@ debug output, r0=val, r1=line, r2=used.
;@----------------------------------------------------------------------------
.if 0
 [ DEBUG
	ldr r2,=DEBUGSCREEN
	add r2,r2,r1,lsl#6
db0
	mov r0,r0,ror#28
	and r1,r0,#0x0f
	cmp r1,#9
	addhi r1,r1,#7
	add r1,r1,#0x30
	orr r1,r1,#0x4100
	strh r1,[r2],#2
	tst r2,#15
	bne db0
 ]
.endif
	bx lr

;@----------------------------------------------------------------------------
vblirqhandler:
;@----------------------------------------------------------------------------
	stmfd sp!,{r4-r9,r11,lr}
	bl showfps_

	ldr r6,bg_scalevalue

	ldr r3,=vdpyscroll1
	ldrb r3,[r3]
	ldr r7,=scrollmask
	ldr r7,[r7]
	ldr r5,=SCROLLBUFF
	ldr r4,=ystart
	ldrsb r4,[r4]
	add r5,r5,r4
	adds r3,r3,r4
	addmi r3,r3,r7

	mul r1,r6,r3
	beq noLoop
	sub r6,r6,r1,lsl#16
	cmn r6,r6,lsl#16
	mov r1,#0
	movcc r1,#1
@	rsbs r1,r3,#0
@	bpl noLoop
@setLoop:
@	adds r6,r6,r6,lsl#16
@	adcs r1,r1,#1
@	bmi setLoop					;@ r1 will come out as 0 or 1.
noLoop:

	ldrb r0,g_flicker
	ldrb r2,g_twitch
	eors r2,r2,r0
	strb r2,g_twitch
	beq nojump
	subs r6,r6,r6,lsl#16
	movcs r1,#1
nojump:
	add r5,r5,r1
	add r3,r3,r1
	cmp r1,#0
	subne r6,r6,r6,lsl#16

	mov r8,r3
	ldr r2,=DMA0BUFF
	mov r4,r2
	subs r3,r3,r7
	subpl r3,r3,r7
	subpl r8,r8,r7
	mov r12,#192
ScrolLoop2:
	ldrb r11,[r5],#1
	add r0,r11,r8,lsl#16
	mov r1,r0
	mov r9,r0
	stmia r4!,{r0-r1,r9,r11}
	subs r6,r6,r6,lsl#16
	subcs r6,r6,r6,lsl#16
	adc r8,r8,#0
	adc r5,r5,#0
	adcs r3,r3,#1
	subcs r8,r8,r7
	subs r12,r12,#1
	bne ScrolLoop2



	mov r6,#REG_BASE
	strh r6,[r6,#REG_DMA0CNT_H]	;@ DMA0 stop

	add r1,r6,#REG_DMA0SAD
@	mov r2,r2					;@ setup DMA buffer for scrolling:
	ldmia r2!,{r4,r5,r7,r8}		;@ Read
	add r3,r6,#REG_BG0HOFS		;@ DMA0 always goes here
	stmia r3,{r4-r5,r7,r8}		;@ set 1st value manually, HBL is AFTER 1st line
	ldr r4,=0x96600004			;@ noIRQ hblank 32bit repeat incsrc inc_reloaddst, 4 word
	stmia r1,{r2-r4}			;@ DMA0 go

	add r1,r6,#REG_DMA3SAD

	ldr r2,=dmaoambuffer
	ldr r2,[r2]					;@ DMA3 src, OAM transfer:
	mov r3,#OAM					;@ DMA3 dst
	mov r4,#0x84000000			;@ noIRQ 32bit incsrc incdst
	orr r4,r4,#0x100			;@ 128 sprites (1024 bytes)
	stmia r1,{r2-r4}			;@ DMA3 go

	ldr r2,=EMUPALBUFF			;@ DMA3 src, Palette transfer:
	mov r3,#BG_PALETTE			;@ DMA3 dst
	mov r4,#0x84000000			;@ noIRQ 32bit incsrc incdst
	orr r4,r4,#0x100			;@ 256 words (1024 bytes)
	stmia r1,{r2-r4}			;@ DMA3 go

	ldr r2,=BGoffset1
	ldr r2,[r2]
	add r0,r2,#0x0005
	strh r0,[r6,#REG_BG0CNT]
	ldr r3,=0x02870106
	add r0,r2,r3
	strh r0,[r6,#REG_BG1CNT]
	strh r0,[r6,#REG_BG3CNT]
	add r0,r2,r3,lsr#16
	strh r0,[r6,#REG_BG2CNT]

	mov r0,#0x001F
	ldrb r1,g_gfxmask
	bic r0,r0,r1
	ldr r1,=vdpmode2_bak2
	ldrb r1,[r1]
	tst r1,#0x40
	biceq r0,r0,#0x001F			;@ Turn off sprites and bg
	orr r0,r0,r0,lsl#8
	bic r0,r0,#0x0008

	ldr r1,=vdpmode1
	ldrb r1,[r1]
	tst r1,#0x80				;@ Columns 24-31 locked?
	biceq r0,r0,#0x0800
	bicne r0,r0,#0x0300

	strh r0,[r6,#REG_WININ]

	tst r1,#0x20				;@ Column 0 blanked?
	ldreqh r0,Window0HValue_normal
	ldrneh r0,Window0HValue_col0
	strh r0,[r6,#REG_WIN0H]
	ldrh r0,Window1HValue
	strh r0,[r6,#REG_WIN1H]
	ldrh r0,WindowVValue
	strh r0,[r6,#REG_WIN0V]
	strh r0,[r6,#REG_WIN1V]

@	ldrh r0,DisplayControl		;@ 1d sprites, Win0, OBJ, BG0/1/2/3 enable. mode0.
@	orrne r0,r0,#0x6000			;@ enable Win0 & 1
@	ldr r2,=vdpmode2_bak2
@	ldrb r2,[r2]
@	tst r2,#0x40
@	biceq r0,r0,#0x1700			;@ Turn off sprites and bg
@	ldrb r2,gfxlayermask
@	bic r0,r0,r2,lsl#8

	ldr r0,=g_emuflags
	ldr r0,[r0]
	tst r0,#PALTIMING
	adreq lr,exit_vbl
	adrne lr,Hz50Start
	ldr r0,=scanKeys
	bx r0
Hz50Start:
	mov r0,#5
Hz50Loop0:
	ldrh r1,[r6,#REG_VCOUNT]
	cmp r1,#212
	beq Hz50Loop0
Hz50Loop1:
	ldrh r1,[r6,#REG_VCOUNT]
	cmp r1,#212
	bne Hz50Loop1
	mov r1,#202
	strh r1,[r6,#REG_VCOUNT]
	subs r0,r0,#1
	bne Hz50Loop0
exit_vbl:
	ldmfd sp!,{r4-r9,r11,pc}

DisplayControl:
	.short 0x3F40,0
Window0HValue_normal:
	.long 0x00E0
Window0HValue_col0:
	.long 0x08E0
Window1HValue:
	.long 0xE000
WindowVValue:
	.long 0x00C0
;@----------------------------------------------------------------------------
bg_scalevalue:	.long 0x00002B10			;@ was 0x2AAB
g_twitch:		.byte 0
g_flicker:		.byte 1
g_gammavalue:	.byte 0
g_gfxmask:		.byte 0
bcolor:			.byte 0
				.byte 0,0,0
;@-------------------------------------------------------------------------------
mode03_newframe:
;@-------------------------------------------------------------------------------
	mov r0,#191
	ldr r1,=scrollXline
	str r0,[r1]

	mov r0,#0
	strb r0,vdpyscroll1
	ldr r0,=SCROLLBUFF
	ldr r1,=0x00
	mov r2,#192/4
	b memset_
;@----------------------------------------------------------------------------
newframe:					;@ called before line 0	(r0-r9 safe to use)
;@----------------------------------------------------------------------------
	mov r0,#-1
	str r0,scanline				;@ reset scanline count
	mov r0,#0
	str r0,nametableline

	ldrb r0,vdpcounter
	str r0,lineirq
	ldrb r0,vdpyscroll
	strb r0,vdpyscroll1

	ldrb r0,vdprmode
	cmp r0,#VDPMODE_4
	bmi mode03_newframe

	ldrb r0,vdpmode1
	ands r0,r0,#0x40
	movne r0,#15				;@ 16 topmost lines frozen.
	str r0,scrollXline

	ldr r0,=SCROLLBUFF
	ldrb r1,vdpxscroll
	rsb r1,r1,#0
	streqb r1,[r0]
	ldrne r1,=0x00000000
	movne r2,#16/4
	bne memset_

	bx lr

;@------------------------------------------------------------------------------
earlyframe:					;@ called at line 0,16 or 32	(r0,r2 safe to use)
;@------------------------------------------------------------------------------
	stmfd sp!,{r1,r3-r9,r11,lr}

	ldr r0,=SPRS
	ldrb r0,[r0]
	cmp r0,#0
	ldreq r0,=default_scanlinehook
	ldrne r0,=SpriteScanner
	ldr r2,=scanlinehook
	str r0,[r2]
	adrne lr,early_end
	bne SpriteScanner_start


	ldrb r0,vdprmode
	cmp r0,#VDPMODE_4
	bleq sprDMA_do_0
early_end:
	ldmfd sp!,{r1,r3-r9,r11,pc}
;@----------------------------------------------------------------------------
midframe:					;@ called at line 96
;@----------------------------------------------------------------------------
	stmfd sp!,{r1,r3-r9,r11,lr}

	ldrb r0,vdpmode2
	strb r0,vdpmode2_bak1		;@ screen on/off

	ldrb r1,vdprmode
	ldrb r0,vdpcalcmode
	strb r0,vdpheightmode
	and r0,r0,#0x0F
	strb r0,vdprmode

	adr lr,NoModeChg
	cmp r0,r1
	bxeq lr
	cmp r0,#VDPMODE_4
	bpl SetBGOffsetsNormal
	bmi SetBGOffsetsMode2
NoModeChg:
	ldmfd sp!,{r1,r3-r9,r11,pc}

;@----------------------------------------------------------------------------
endframe:					;@ called just before screen end (~line 240)	(r0-r2 safe to use)
;@----------------------------------------------------------------------------
	stmfd sp!,{r1,r3-r9,r11,lr}

	ldr r0,=default_scanlinehook
	ldr r1,=scanlinehook
	str r0,[r1]
	ldrb r0,nametable
	mov addy,#224
	bl NT_finnish
	bl bg_finish
;@--------------------------
	adr lr,sDMARet
	ldrb r0,vdprmode
	cmp r0,#VDPMODE_4
	bmi sprDMA_do_m2
	beq sprDMA_do_1
sDMARet:
;@--------------------------
	ldr r0,=g_machine
	ldrb r0,[r0]
	cmp r0,#HW_GG
	bleq PaletteTxGGSG
;@--------------------------
	ldrb r1,vdpxscroll
	bl VDPreg08_W

	ldr r2,=EMUPALBUFF
	ldr r1,=bcolor
	ldrb r0,[r1]
	cmp r0,#0
	ldreq r1,=g_machine
	ldreqb r1,[r1]
	cmpeq r1,#HW_GG
	beq setbc
	ldrb r0,vdpmode1
	add r3,r2,#0x80				;@ SG palette
	tst r0,#0x04				;@ mode4?
	addne r3,r3,#0x180			;@ use normal palette
	ldrb r4,bdcolor
	and r1,r4,#0xF				;@ Border color
	add r1,r3,r1,lsl#1
	ldrh r0,[r1]

	mov r1,r4,lsr#4				;@ Text color for TMS9918 modes.
	add r1,r3,r1,lsl#1
	ldrh r1,[r1]
	strh r1,[r2,#64+2]
setbc:
	strh r0,[r2]				;@ color 0


	ldrb r0,vdpmode2_bak1
	strb r0,vdpmode2_bak2

	ldr r0,dmaoambuffer
	ldr r1,tmpoambuffer
	str r0,tmpoambuffer
	str r1,dmaoambuffer

	adrl r0,BGoffset1
	ldmib r0,{r1-r2}			;@ load with pre increment
	ldr r3,BGoffset1
	stmia r0,{r1-r3}			;@ store with post increment

	mov r0,#1
	str r0,oambufferready

	ldr r0,=windowtop			;@ load wtop, store in wtop+4.......load wtop+8, store in wtop+12
	ldmia r0,{r1-r3}			;@ load with post increment
	stmib r0,{r1-r3}			;@ store with pre increment


//	bl Transfer_VRAM
	bl Delay_VRAM
	ldmfd sp!,{r1,r3-r9,r11,lr}
	bx lr
	
;@----------------------------------------------------------------------------
VDPctrl_MD_W:
;@----------------------------------------------------------------------------
	ldrb r1,toggle
	eors r1,r1,#1
	strb r1,toggle

	strneb r0,vdpbuff_md
	bxne lr
	and r0,r0,#0xFF
	ldrb r1,vdpbuff_md
	orr r2,r1,r0,lsl#8
	ldr r1,vramaddr
	mov r1,r1,lsl#14
	mov r1,r1,lsr#14
	orr r1,r1,r2,lsl#18
	str r1,vramaddr

	ldrb r2,vdprmode
	cmp r2,#VDPMODE_5
	bne vdpctrl_b_w
	mov r2,r0,lsr#6
	cmp r2,#2
	ldrneb r2,toggle
	eorne r2,r2,#2
	strneb r2,toggle

	b vdpctrl_b_w

;@----------------------------------------------------------------------------
VDPctrl_W:
;@----------------------------------------------------------------------------
	ldrb r1,toggle
	eors r1,r1,#1
	strb r1,toggle

	and r0,r0,#0xFF
	ldr r1,vramaddr
	biceq r1,r1,#0xFC000000
	bicne r1,r1,#0x03FC0000
	orreq r1,r1,r0,lsl#26
	orrne r1,r1,r0,lsl#18
	str r1,vramaddr
	bxne lr
vdpctrl_b_w:
	movs r0,r0,lsr#6
	strb r0,vdpctrl
	adr r2,VDPMemDest
	ldr r0,[r2,r0,lsl#2]
	ldr r2,=VDPdata_W_ptr
	str r0,[r2]
	ldrb r0,vdpctrl
	ldr pc,[pc,r0,lsl#2]
	bx lr
VDPdest:
	.long VDPctrl0_W
	.long VDPctrl1_W
	.long VDPctrl2_W
	.long VDPctrl3_W
VDPMemDest:
	.long VRAM_W
	.long VRAM_W
	.long VRAM_W
	.long CRAM_SMS_W
;@----------------------------------------------------------------------------
VDPctrl0_W:					;@ Set read address, fill buffer.
;@----------------------------------------------------------------------------
	ldr r0,=VDP_RAM
	ldrb r0,[r0,r1,lsr#18]
	strb r0,vdpbuff
	add r1,r1,#0x00040000
	str r1,vramaddr
VDPctrl1_W:
VDPctrl3_W:
	bx lr
;@----------------------------------------------------------------------------
VDPctrl2_W:					;@ Write to vdp registers.
;@----------------------------------------------------------------------------
	mov r1,r1,lsr#18
VDPRegMask:
	and r0,r1,#0x0F00
	ldr pc,[pc,r0,lsr#6]
	.long 0
VDPregs_jmp_table:
	.long VDPreg00_W
	.long VDPreg01_W
	.long VDPreg02_W
	.long VDPreg03_W
	.long VDPreg04_W
	.long VDPreg05_W
	.long VDPreg06_W
	.long VDPreg07_W
	.long VDPreg08_W
	.long VDPreg09_W
	.long VDPreg0A_W
	.long VDPreg0F_W
	.long VDPreg0F_W
	.long VDPreg0F_W
	.long VDPreg0F_W
	.long VDPreg0F_W

	.long VDPreg0F_W
	.long VDPreg0F_W
	.long VDPreg0F_W
	.long VDPreg0F_W
	.long VDPreg0F_W
	.long VDPreg0F_W
	.long VDPreg0F_W
	.long VDPreg0F_W
	.long VDPreg0F_W
	.long VDPreg0F_W
	.long VDPreg0F_W
	.long VDPreg0F_W
	.long VDPreg0F_W
	.long VDPreg0F_W
	.long VDPreg0F_W
	.long VDPreg0F_W
.pool
;@----------------------------------------------------------------------------
VDPreg00_W:
;@----------------------------------------------------------------------------
	strb r1,vdpmode1
	b SetVDPMode
;@----------------------------------------------------------------------------
VDPreg01_MD_W:
;@----------------------------------------------------------------------------
	and r1,r1,#0xFE				;@ Mask out zoomed sprites on MD.
;@----------------------------------------------------------------------------
VDPreg01_W:
;@----------------------------------------------------------------------------
	strb r1,vdpmode2
;@----------------------------------------------------------------------------
SetVDPMode:
;@----------------------------------------------------------------------------
	ldrb r0,vdpmode1
	ldrb r1,vdpmode2
	mov r0,r0,lsr#1
	orr r0,r0,r1,lsl#27
	mov r0,r0,ror#2
	ldr r1,=VDPModes
	ldrb r0,[r1,r0,lsr#27]
	strb r0,vdpcalcmode

	ldr r1,=g_emuflags
	ldr r1,[r1]
	tst r1,#PALTIMING
	mov r1,#0xDA
	addne r1,r1,#0x18			;@ NTSC/PAL diff

	ands r0,r0,#0x30			;@ 224 and/or 240 height
	addne r1,r1,#0x10
	str r1,scanlinebp
	mov r1,#208					;@ Sprite stop pos.
	movne r1,#0x200
	str r1,sprstop
	ldr r2,=BG_SCALING_TBL
	ldr r1,[r2,r0,lsr#2]
	str r1,bg_scalevalue
	ldr r2,=BG_SCALING_WIN
	ldr r1,[r2,r0,lsr#2]
	str r1,WindowVValue
	ldr r2,=BG_SCALING_OFS
	ldr r1,[r2,r0,lsr#2]
	strb r1,ystart


	moveq r1,#32				;@ maxpan
	movne r1,#64
	add r0,r1,#192				;@ 224/256
	str r0,scrollmask
	sub r0,r0,#32
	str r0,vblline
	moveq r0,#0xE
	movne r0,#0xC
	ldr r2,=g_machine
	ldrb r2,[r2]
	cmp r2,#HW_SG1000
	cmpne r2,#HW_SMS1
	orrne r0,r0,#1
	strb r0,ntmask

	ldr r0,=g_emuflags
	ldrb r0,[r0]
	tst r0,#GG_MODE

	movne r0,#152
	addne r0,r0,r1,lsr#1
	addeq r0,r1,#160
	str r0,endframeline

	mov r0,#0
	movne r0,r1,lsr#1
	movne r1,r1,lsr#1
	strb r0,minpan
	strb r1,maxpan
	addne r0,r0,#8
	strb r0,scrstartline

;@----------------------------------------------------------------------------
Check_VDP_IRQ:
;@----------------------------------------------------------------------------
	ldrb r1,vdpmode2
	ldrb r0,vdpstat
	and r0,r0,#0x80
	ands r0,r0,r1,lsl#2

	ldreqb r1,vdpmode1
	ldreqb r0,vdppending
	andeqs r0,r0,r1,lsl#2
	strb r0,[z80optbl,#z80_irq_pin]

	bx lr
;@----------------------------------------------------------------------------
VDPreg02_W:
;@----------------------------------------------------------------------------
	ldrb r0,nametable
	strb r1,nametable

	ldr addy,scanline			;@ addy=scanline
NT_finnish:
;@	add addy,addy,#1			;@ maybe check cycles and add 2 sometimes?
	cmp addy,#224
	movhi addy,#224
	adr r2,nametableline
	swp r1,addy,[r2]			;@ r1=lastline, lastline=scanline

	ldr r2,=TMAPBUFF
	add r1,r2,r1
	add r2,r2,addy
nt1:
	strb r0,[r2],#-1			;@ fill backwards from scanline to lastline
	cmp r2,r1
	bpl nt1
	bx lr

nametableline: .long 0			;@ ..was when?

;@----------------------------------------------------------------------------
VDPreg03_W:					;@ Color Table - offset
;@----------------------------------------------------------------------------
	strb r1,ctoffset
	bx lr
;@----------------------------------------------------------------------------
VDPreg04_W:					;@ Pattern Generator Table - offset
;@----------------------------------------------------------------------------
	strb r1,pgoffset
	bx lr
;@----------------------------------------------------------------------------
VDPreg05_W:					;@ Sprite Attribute Table - offset
;@----------------------------------------------------------------------------
	strb r1,satoffset
	bx lr
;@----------------------------------------------------------------------------
VDPreg06_W:					;@ Sprite tiles - offset
;@----------------------------------------------------------------------------
	strb r1,sproffset
	bx lr
;@----------------------------------------------------------------------------
VDPreg07_W:					;@ Backdrop Color
;@----------------------------------------------------------------------------
	strb r1,bdcolor
	bx lr
;@----------------------------------------------------------------------------
VDPreg08_W:					;@ Horizontal Scroll register
;@----------------------------------------------------------------------------
	ldrb r0,vdpxscroll
	strb r1,vdpxscroll
	rsb r0,r0,#0

	ldr addy,scanline			;@ addy=scanline
	rsbs r2,cycles,#11*CYCLE
	adc addy,addy,#0			;@ Also add carry if cycles < 11
	cmp addy,#225
	movhi addy,#225
	ldr r1,scrollXline
	cmp r1,addy
	movpl pc,lr
	str addy,scrollXline

	ldr r2,=SCROLLBUFF
	add r1,r2,r1
	add r2,r2,addy
sx1:
	strb r0,[r2],#-1			;@ fill backwards from scanline to lastline
	cmp r2,r1
	bhi sx1
	bx lr

scrollXline: .long 0			;@..was when?

;@----------------------------------------------------------------------------
VDPreg09_W:					;@ Vertical Scroll register
;@----------------------------------------------------------------------------
	strb r1,vdpyscroll
	bx lr
;@----------------------------------------------------------------------------
VDPreg0A_W:					;@ HBlank value
;@----------------------------------------------------------------------------
	strb r1,vdpcounter
;@	bx lr
;@----------------------------------------------------------------------------
;VDPreg0B_W:				;@ MD, Mode Set Register No. 3
;@----------------------------------------------------------------------------
;@	bx lr
;@----------------------------------------------------------------------------
;VDPreg0C_W:				;@ MD, Mode Set Register No. 4
;@----------------------------------------------------------------------------
;@	bx lr
;@----------------------------------------------------------------------------
;VDPreg0D_W:				;@ MD, H Scroll Data Table Base Address
;@----------------------------------------------------------------------------
;@	bx lr
;@----------------------------------------------------------------------------
VDPreg0F_W:					;@ MD, Auto Increment Data
;@----------------------------------------------------------------------------
	bx lr
;@----------------------------------------------------------------------------
;VDPreg10_W:				;@ MD, H Scroll Data Table Base Address
;@----------------------------------------------------------------------------
;@	bx lr

;@-------------------------------------------------------------------------------
HCounter_Latch:				;@ 228cpu=684vdp, r0 & r2 free to use.
;@-------------------------------------------------------------------------------
;@	mov r11,r11					;@ No$GBA breakpoint
	ldrb r0,hcountoffset		;@ 27/26 cycles.
	rsbs r0,r0,cycles,asr#CYC_SHIFT	;@ Tweak for OUT instruction taking some cycles before writing value to port.
	addmi r0,r0,#228
	add r0,r0,r0,lsl#1			;@ cycle*3
	rsb r0,r0,#600				;@ hc=(0xE9->0x93)
	sub r0,r0,#10
	mov r0,r0,asr#2
	strb r0,hcountlatch
	bx lr

;@----------------------------------------------------------------------------
SpriteScanner_start:
	stmfd sp!,{r3-r9}
;@	mov r11,r11

	ldr r9,=VDP_RAM
	ldrb r0,satoffset
	and r0,r0,#0x7E
	add r9,r9,r0,lsl#7
	add r8,r9,#0x80

	ldrb r0,ntmask
	and r0,r0,#0xE
	cmp r0,#0xC
	movne r2,#0xFFFFFFD0		;@ 208 = 0xD0
	moveq r2,#0x200

	ldr r4,=SMSOAMBUFF
	add r3,r4,#0x80
	ldrb r5,scrstartline
	sub r1,r5,#0xF
	mov r6,#0
	mov r7,#0
ss1_loop:
	ldrsb r0,[r9,r7]			;@ MasterSystem OBJ, r0=Ypos.
	cmp r0,r2
	beq ss1_end
	cmp r0,r5
	bgt ss1_chk
	cmp r0,r1
	bpl ss1_add
ss1_chk:
	add r7,r7,#1
	cmp r7,#0x40
	bne ss1_loop
ss1_end:
	ldr r0,=smsoamptr
	str r6,[r0]
	strb r2,[r4,r6,lsr#1]
	ldmfd sp!,{r3-r9}
	bx lr
	
ss1_add:
	strb r0,[r4,r6,lsr#1]
	mov r0,r7,lsl#1
	ldrh r0,[r8,r0]				;@ MasterSystem OBJ, r4=Tile,Xpos.
	strh r0,[r3,r6]
	cmp r6,#0xFE
	addmi r6,r6,#2
	bmi ss1_chk
	b ss1_end

;@----------------------------------------------------------------------------
SpriteScanner:
	stmfd sp!,{r4-r9}

	ldr r9,=VDP_RAM
	ldrb r0,satoffset
	and r0,r0,#0x7E
	add r9,r9,r0,lsl#7
	add r8,r9,#0x100

	ldr r2,sprstop
	ldr r4,=SMSOAMBUFF
	add r5,r4,#0x80
;@	ldr r1,scanline				;@ r1 is allready scanline.
	ldr r6,smsoamptr
	mov r7,#-0x80
ss0_loop:
	ldrb r0,[r9],#1				;@ MasterSystem OBJ, r0=Ypos.
	cmp r0,r2
	cmpne r0,r1
	beq ss0_add
ss0_chk:
	adds r7,r7,#2
	bne ss0_loop
ss0_end:
	str r6,smsoamptr
	strb r2,[r4,r6,lsr#1]
	ldmfd sp!,{r4-r9}
	b default_scanlinehook

ss0_add:
	cmp r0,r2
	beq ss0_end

	strb r0,[r4,r6,lsr#1]
	ldrh r0,[r8,r7]				;@ MasterSystem OBJ, r4=Tile,Xpos.
	strh r0,[r5,r6]
	cmp r6,#0xFE
	addmi r6,r6,#2
	bmi ss0_chk
	b ss0_end

;@----------------------------------------------------------------------------
;@sprDMA_do:				;@ Called from endframe. YATX
;@----------------------------------------------------------------------------
#define PRIORITY	(0x800)		// 0x800=AGB OBJ priority 2

sprDMA_do_0:					;@ Called from newframe.
	ldr r2,tmpoambuffer			;@ Destination
	b sprpass_do_m4

sprDMA_do_1:					;@ Called from endframe.
	ldr r2,tmpoambuffer			;@ Destination
	ldrb r0,SPRS
	cmp r0,#0
	ldrne addy,=SMSOAMBUFF
	movne r8,#128				;@ number of sprites
	bne sprs_do
	addeq r2,r2,#0x200


sprpass_do_m4:
	mov r8,#64					;@ number of sprites
	ldr addy,=VDP_RAM
	ldrb r0,satoffset
	and r0,r0,#0x7E
	add addy,addy,r0,lsl#7
sprs_do:
	mov r6,#0x100				;@ r6= scale obj

	ldr r11,sprstop
	ldrb r0,vdpmode2
	movs r0,r0,lsl#31			;@ double pixels/8x16 size
	orrmi r6,r6,#0x00000200		;@ doublesize
	orrmi r6,r6,#0x04000000		;@ scaling param
	orrcs r6,r6,#0x00008000		;@ 8x16 shape
	orrcs r6,r6,#0x02000000		;@ scaling param

	ldr r5,bg_scalevalue
	add r5,r5,#1
	ldr r4,=ystart				;@ first scanline?
	ldrsb r4,[r4]				;@ first scanline?
dm4_1:
	add r9,addy,#0x80
	mov r7,#PRIORITY
	ldrb r0,sproffset			;@ First or second half of VRAM for sprites?
	tst r0,#4
	orrne r7,r7,#0x100
	ldrb r1,vdpmode1
	and r1,r1,#8
	mov r1,r1,lsl#23
dm4_2:
	ldrb r0,[addy],#1			;@ MasterSystem OBJ, r0=Ypos.
	ldrh r4,[r9],#2				;@ MasterSystem OBJ, r4=Tile,Xpos.
	cmp r0,r11
	beq dm4_3					;@ skip the rest if sprite Y=208

	cmp r0,#0xEF
	subpl r0,r0,#0x100
	add r0,r0,#1
	ldr r3,=ystart
	ldrsb r3,[r3]
	sub r0,r0,r3

	mov r3,#4
	tst r6,#0x02000000
	movne r3,r3,lsl#1
	tst r6,#0x04000000
	movne r3,r3,lsl#1
	add r0,r0,r3

	mul r0,r5,r0
	sub r0,r0,r3,lsl#16
	and r0,r0,#0xFF0000
	orr r0,r6,r0,lsr#16			;@ size plus scaling?
	and r3,r4,#0xFF
	rsb r3,r1,r3,lsl#23
	orr r0,r0,r3,lsr#7
	str r0,[r2],#4				;@ store OBJ Atr 0,1. Xpos, ypos, flip, scale/rot, size, shape.

	bic r4,r4,r6,lsr#7			;@ only even tiles in 8x16 mode
	orr r0,r7,r4,lsr#8			;@ priority & tile offset
	strh r0,[r2],#4				;@ store OBJ Atr 2. Pattern, palette.
	subs r8,r8,#1
	bne dm4_2
	bx lr

dm4_3:
	mov r0,#0x2C0				;@ double, y=192
dm4_4:
	str r0,[r2],#8
	subs r8,r8,#1
	bne dm4_4
	bx lr



;@----------------------------------------------------------------------------
sprDMA_do_m2:				;@ Called from endframe.
;@----------------------------------------------------------------------------
	ldr r2,tmpoambuffer			;@ Destination

	ldr addy,=VDP_RAM
	ldrb r0,satoffset
	and r1,r0,#0x7F
	add addy,addy,r1,lsl#7

	mov r6,#0x100				;@ r6= scale obj

	ldrb r0,vdpmode2
	movs r0,r0,lsl#31			;@ double pixels/16x16 size
	orrmi r6,r6,#0x00000200		;@ doublesize
	orrmi r6,r6,#0x04000000		;@ scaling param
	orrcs r6,r6,#0x00008000		;@ 8x16 shape
	orrcs r6,r6,#0x02000000		;@ scaling param

	ldr r5,bg_scalevalue
	add r5,r5,#1
	mov r0,#0
	ldr r4,=ystart				;@ first scanline?
	ldrsb r4,[r4]				;@ first scanline?
	bhi dm2_1
	movle r4,#0
	bne dm2_0
	ldrb r0,[addy,r1,lsr#16]	;@ follow sprite
	sub r0,r0,#0x60
	adds r0,r0,r0,asr#3
	movmi r0,#0
	ldrb r1,maxpan
	cmp r0,r1
	movpl r0,r1
	str r0,windowtop
dm2_0:
	ldr r0,windowtop+8
dm2_1:
	add r4,r4,r0
	tst r6,r6,lsl#11			;@ 16x16 size + scaling?
	mov r8,#32					;@ number of sprites
	mov r7,#PRIORITY+0x300
	mov r1,#0x10000000
dm2_2:
	ldr r4,[addy],#4			;@ MasterSystem OBJ, r0=Ypos.
	mov r0,r4,lsl#24
	cmp r0,#0xD0000000
	beq dm2_3					;@ skip the rest if sprite Y=208
	and r9,r4,#0xFF00
	and r3,r1,r4,lsr#3			;@ EC early clock, x -=32.
	rsb r9,r3,r9,lsl#15

	mov r0,r0,lsr#24
	cmp r0,#0xEF
	subpl r0,r0,#0x100
	add r0,r0,#1
	ldr r3,=ystart
	ldrsb r3,[r3]
	sub r0,r0,r3

	mov r3,#4					;@ Sprites are scaled around the center
	tst r6,#0x02000000			;@ That's why this is needed
	movne r3,r3,lsl#1
	tst r6,#0x04000000
	movne r3,r3,lsl#1
	add r0,r0,r3

	mul r0,r5,r0
	sub r0,r0,r3,lsl#16
	and r0,r0,#0xFF0000
	orr r0,r6,r0,lsr#16			;@ size plus scaling?
	tst r4,#0xF000000			;@ Color 0 sprite = invisible.
	moveq r0,#0x2C0				;@ double, y=192
	orr r3,r0,r9,lsr#7
	str r3,[r2],#4				;@ store OBJ Atr 0,1. Xpos, ypos, flip, scale/rot, size, shape.

	mov r4,r4,ror#24
	orr r3,r7,r4,lsr#24			;@ tiles + tileoffset + priority
	orr r3,r3,r4,lsl#12			;@ palette
	tst r6,#0x00008000			;@ 16x16 size?
	bicne r3,r3,#3				;@ only even tiles in 16x16 mode
	strh r3,[r2],#4				;@ store OBJ Atr 2. Pattern, palette.

	moveq r0,#0x2C0				;@ double, y=192
	addne r3,r3,#2				;@ tile+2
	addne r9,r9,#0x04000000
	tstne r6,#0x00000200		;@ zoom?
	addne r9,r9,#0x04000000
	orr r0,r0,r9,lsr#7
	str r0,[r2],#4				;@ store OBJ Atr 0,1. Xpos, ypos, flip, scale/rot, size, shape.
	strh r3,[r2],#4				;@ store OBJ Atr 2. Pattern, palette.

	subs r8,r8,#1
	bne dm2_2
;@	bx lr

dm2_3:
	add r8,r8,#32
	mov r0,#0x2C0				;@ double, y=192
dm2_4:
	str r0,[r2],#8
	str r0,[r2],#8
	subs r8,r8,#1
	bne dm2_4
	bx lr

;@----------------------------------------------------------------------------
bg_finish:					;@ end of frame...
;@----------------------------------------------------------------------------
	stmfd sp!,{r3-r9,r11,lr}


;@	b bg_cont

;@	ldrb r0,frame
;@	tst r0,#0x7
;@	ldmnefd sp!,{r3-r9,r11,pc}
bg_cont:
;@	mov r0,#0
;@	strb r0,[r4]

	mov addy,#BG_GFX
	ldr r0,BGoffset2
	add addy,addy,r0,lsl#3
	ldr r5,=0xF000F000
	ldr r6,=0x000003FF
	ldr r7,=0x00010001
	ldrb lr,vdpyscroll1
	and r0,lr,#7
	mov lr,lr,lsr#3
	rsbs r1,r0,#4
	movmi r1,#0
	ldr r8,=TMAPBUFF
	ldrb r1,[r8,r1]!
	ldrb r2,vdpheightmode
	cmp r2,#VDPMODE_4_224
	cmpne r2,#VDPMODE_4_240
	ldr r11,=VDP_RAM
	addeq r11,r11,#0x700
	mov r9,#28
	moveq r9,#32

	and r2,r2,#0x0F
	cmp r2,#VDPMODE_4
	beq bgmode4
	cmp r2,#VDPMODE_5
	beq bgmode5

	mov r8,#0
	cmp r2,#VDPMODE_2
	ldreq r8,=0x01000100
	and r1,r1,#0xF
	add r3,r11,r1,lsl#10

	mov r4,addy
	mov r0,#0
	ldr r7,=0x40C040C0			;@ palette 4 & tileoffset
	ldr r9,=0x00020002

	mov r6,#3
	cmp r2,#VDPMODE_0
	cmpne r2,#VDPMODE_2
	beq bgmode02
	cmp r2,#VDPMODE_1
	bne bgmode_b
;@----------------------------------------------------------------------------
bgmode1:
	ldr r7,=0x20C020C0			;@ palette 2
	mov r6,#24
bgm1loop:
	mov r5,#16
bgm1row:
	ldrh r1,[r3],#2				;@ Read from MasterSystem Tilemap RAM
	orr r1,r1,r1,lsl#8
	bic r1,r1,#0xFF00
	add r1,r1,r7				;@ palette & tileoffset

	str r0,[r4,r9,lsr#5]		;@ Write to GBA Tilemap RAM, BGR color
	str r1,[r4,#0x800]			;@ Write to GBA Tilemap RAM, behind sprites
	str r0,[r4],#4				;@ Write to GBA Tilemap RAM, in front of sprites
	subs r5,r5,#1
	bne bgm1row
	add r3,r3,#8
	subs r6,r6,#1
	bne bgm1loop
bgmode_b:
	ldmfd sp!,{r3-r9,r11,pc}

;@----------------------------------------------------------------------------
;@bgchrfinish				;@ end of frame...
;@----------------------------------------------------------------------------
;@	mov r0,#0
;@	ldr r7,=0x40004000
;@	ldr r9,=0x00020002
bgmode02:						;@ fake

bgm2loop2:
	mov r5,#16*8
bgm2loop:
	ldrh r1,[r3],#2				;@ Read from MasterSystem Tilemap RAM
	orr r1,r1,r1,lsl#8
	bic r1,r1,#0xFF00
	add r1,r1,r7				;@ palette & tile offset.

	str r0,[r4,r9,lsr#5]		;@ Write to GBA Tilemap RAM, BGR color
	str r1,[r4,#0x800]			;@ Write to GBA Tilemap RAM, behind sprites
	str r0,[r4],#4				;@ Write to GBA Tilemap RAM, in front of sprites
	subs r5,r5,#1
	bne bgm2loop
	add r7,r7,r8				;@ add tileoffset for group.
	subs r6,r6,#1
	bne bgm2loop2

	ldmfd sp!,{r3-r9,r11,pc}


;@----------------------------------------------------------------------------
;@bgchrfinish				;@ end of frame...
;@----------------------------------------------------------------------------
;@	ldr r5,=0xF000F000
;@	ldr r6,=0x000003FF
;@	ldr r7,=0x00010001
;@ MSB          LSB
;@ ---pcvhnnnnnnnnn
bgmode4:
	ldr r2,=0x02000200
bgm4frame:
	ldrb r1,[r8],#8
	ldrb r0,ntmask
	movs r0,r0,lsr#1
	orrcs r1,r1,#0x01
	ands r0,r0,r1,lsr#1
	orr r0,lr,r0,lsl#5
	biccc r0,r0,#0x10
	add r3,r11,r0,lsl#6
	add r4,addy,lr,lsl#6

	add lr,lr,#1
	ldr r0,scrollmask
	cmp lr,r0,lsr#3
	subpl lr,lr,r0,lsr#3

bgm4row:
	ldr r0,[r3],#4				;@ Read from MasterSystem Tilemap RAM

	and r1,r7,r0,lsr#11
	orr r1,r1,r7,lsl#1			;@ bgr color 0x30 & 0x40
	str r1,[r4,r7,lsr#4]		;@ Write to GBA Tilemap RAM, BGR color

	tst r7,r0,lsl#4				;@ shift out top P bit, test low P bit.
	bic r0,r0,r5
	and r1,r0,r5,lsr#3
	add r0,r0,r1				;@ XY flip + color.

	add r0,r0,r2				;@ New tile offset
	str r0,[r4,#0x800]			;@ Write to GBA Tilemap RAM, behind sprites
	biccc r0,r0,r6,lsl#16
	biceq r0,r0,r6
	str r0,[r4],#4				;@ Write to GBA Tilemap RAM, in front of sprites
	tst r4,#0x3C				;@ 32 tiles wide
	bne bgm4row
	subs r9,r9,#1
	bne bgm4frame

	ldmfd sp!,{r3-r9,r11,pc}

;@----------------------------------------------------------------------------
bgmode5:
	ldr r2,=0x01C001C0
	ldr r5,=0xFC00FC00
;@	ldr r6,=0x000003FF
;@	ldr r7,=0x00010001
;@	addy = NDS destination address
;@	lr = y scroll row
;@	r11 = VDP_RAM
;@ MSB          LSB
;@ pccvhnnnnnnnnnnn
bgm5loop:
	ldrb r0,[r8],#8
	and r0,r0,#0x08				;@ 0x2000, should be 0x1C
	orr r0,lr,r0,lsl#4
	add r3,r11,r0,lsl#6
	add r4,addy,lr,lsl#6

	add lr,lr,#1
;@	ldr r0,scrollmask
	mov r0,#256
	cmp lr,r0,lsr#3
	subpl lr,lr,r0,lsr#3

bgm5row:
	ldr r0,[r3],#4				;@ Read from MegaDrive Tilemap RAM

	and r1,r7,r0,lsr#11
	str r1,[r4,r7,lsr#4]		;@ Write to NDS Tilemap RAM, BGR color

	bic r1,r0,r5
	and r0,r5,r0,lsr#1
	add r0,r0,r2				;@ Tile offset.
	orr r0,r0,r7,lsl#15			;@ MD palette
	orr r1,r1,r0				;@ XY flip + color.

	str r1,[r4,#0x800]			;@ Write to NDS Tilemap RAM, behind sprites
	mov r1,#0
	str r1,[r4],#4				;@ Write to NDS Tilemap RAM, in front of sprites
	tst r4,#0x3C				;@ 32 tiles wide
	bne bgm5row
	subs r9,r9,#1
	bne bgm5loop

	ldmfd sp!,{r3-r9,r11,pc}


;@----------------------------------------------------------------------------
;@CRAM_MD_W:
;@----------------------------------------------------------------------------
;@	strb z80a,toggle			;@ MD doesn't touch the vdpbuffer on write
;@	b cram_b_w
;@----------------------------------------------------------------------------
CRAM_SMS_W:
;@----------------------------------------------------------------------------
	str r0,vdpbuff				;@ write to vdpbuffer and clear vdptoggle.
cram_b_w:
	ldr r1,vramaddr
	add r2,r1,#0x00040000
	str r2,vramaddr

	and r0,r0,#0x3F
	orr r2,r0,r0,lsl#4
	bic r2,r2,#0xFC
	and r0,r0,#0x0C
	orr r0,r2,r0,lsl#2
	orr r0,r0,r0,lsl#2

	movs r1,r1,lsr#18
	b Write_Pal

;@----------------------------------------------------------------------------
CRAM_GG_W:
;@----------------------------------------------------------------------------
	ldr r1,vramaddr
	add r2,r1,#0x00040000
	str r2,vramaddr
	ldrb r2,vdpbuff
	str r0,vdpbuff				;@ write to vdpbuffer and clear vdptoggle.

	movs r1,r1,lsr#19
	bxcc lr

	and r0,r0,#0x0F
	orr r0,r2,r0,lsl#8
Write_Pal:
	and r1,r1,#0x1F
	ldr r2,=PALETTE_RAM
	add r2,r2,r1,lsl#1
	strh r0,[r2]
	ldr r2,=MAPPED_RGB
	mov r0,r0,lsl#1
	ldrh r0,[r2,r0]
	ldr r2,=EMUPALBUFF
	add r2,r2,r1,lsl#1
	movs r1,r1,lsl#28
	strneh r0,[r2]				;@ bgtile palette
	streqh r0,[r2,#0x40]		;@ background palette
	movcs r1,#480
	strcsh r0,[r2,r1]			;@ sprite palette

	bx lr
;@----------------------------------------------------------------------------
CRAM_MD_W:
;@----------------------------------------------------------------------------
	strb z80a,toggle			;@ MD doesn't touch the vdpbuffer on write
	ldrb r1,vdprmode
	cmp r1,#VDPMODE_5
	bne cram_b_w

	ldr r1,vramaddr
	add r2,r1,#0x00040000
	str r2,vramaddr
	ldrb r2,vdpbuff
	str r0,vdpbuff				;@ write to vdpbuffer and clear vdptoggle.

	movs r1,r1,lsr#19
	bxcc lr

	and r0,r0,#0x0F
	orr r0,r2,r0,lsl#8
	bic r2,r0,#0x0770
	orr r0,r0,r2,lsr#3

Write_Pal_MD:
	stmfd sp!,{r3,r4}
	and r1,r1,#0x3F
	ldr r2,=PALETTE_RAM
	add r2,r2,r1,lsl#1
	strh r0,[r2]
	ldr r4,=MAPPED_RGB
	mov r3,r0,lsl#1
	ldrh r3,[r4,r3]
	ldr r2,=EMUPALBUFF+0x100
	add r2,r2,r1,lsl#1
	strh r3,[r2,#0x80]			;@ bgtile palette high prio

	bic r0,r0,#0x0110
	bic r0,r0,#0x0001
	ldrh r0,[r4,r0]
	strh r0,[r2]				;@ bgtile palette low prio
	ldmfd sp!,{r3,r4}

	bx lr
;@----------------------------------------------------------------------------
VDPdata_R:
;@----------------------------------------------------------------------------
	ldr r1,vramaddr
	add r0,r1,#0x00040000
	str r0,vramaddr
	ldr r0,=VDP_RAM
	ldrb r1,[r0,r1,lsr#18]
	ldrb r0,vdpbuff
	str r1,vdpbuff				;@ write to vdpbuffer and clear vdptoggle.

	bx lr
;@----------------------------------------------------------------------------
VDPstat_R:
;@----------------------------------------------------------------------------
;@	mov r11,r11					;@ No$GBA breakpoint
	strb z80a,toggle
	ldrb r0,vdpstat
	strb z80a,vdpstat
	strb z80a,vdppending
	strb z80a,[z80optbl,#z80_irq_pin]

	bx lr
;@----------------------------------------------------------------------------
VCounter_R:
;@----------------------------------------------------------------------------
;@	mov r11,r11					;@ No$GBA breakpoint
	ldr r0,scanline
	ldrb r1,vcountbp
	cmp cycles,r1,lsl#CYC_SHIFT
	addcc r0,r0,#1				;@ unsigned lower
	ldr r1,scanlinebp
	cmp r0,r1
	ldrhib r1,scanlineminus
	subhi r0,r0,r1
	bx lr
;@----------------------------------------------------------------------------
HCounter_R:
;@----------------------------------------------------------------------------
	ldrb r0,hcountlatch
	bx lr

;@----------------------------------------------------------------------------
VRAM_MD_W:
;@----------------------------------------------------------------------------
	strb z80a,toggle			;@ MD doesn't touch the vdpbuffer on write
	b vram_b_w
;@----------------------------------------------------------------------------
VDPdata_W:
VRAM_W:
;@----------------------------------------------------------------------------
	str r0,vdpbuff			;@ write to vdpbuffer and clear vdptoggle.
vram_b_w:
	ldr r1,vramaddr
	add r2,r1,#0x00040000
	str r2,vramaddr

	ldr r2,=VDP_RAM
	strb r0,[r2,r1,lsr#18]

	strb z80a,[pc,r1,lsr#23]
	bx lr
DIRTYTILES:					;@ bit0=mode0 bgr, bit1=mode1 bgr, bit2=mode2 bgr, bit3=mode3 bgr, bit4=mode0,2,3 spr, bit5=mode4 spr bgr, bit6=mode5 spr bgr,7=?
	.space 0x200
;@----------------------------------------------------------------------------
DMA0BUFPTR:			.long 0

tmpoambuffer:		.long OAM_BUFFER1
dmaoambuffer:		.long OAM_BUFFER2

smsoamptr:			.long 0
oambufferready:		.long 0
pcepaletteready:	.long 0
;@----------------------------------------------------------------------------

FPSValue:
	.long 0
AGBinput:			;@ this label here for main.c to use
	.long 0			;@ AGBjoypad (why is this in gfx.s again?  um.. i forget)
EMUinput:
	.long 0			;@ EMUjoypad (this is what Emu sees)
adjustblend:
	.long 1
windowtop:
	.long 0
wtop:
	.long 0,0,0		;@ windowtop  (this label too)   L/R scrolling in unscaled mode
scanline:
	.long 0
frametotal:			;@ let ui.c see frame count for savestates
	.long 0
lastscanline:
	.long 0
BGoffset1:	.long 0
BGoffset2:	.long 0
BGoffset3:	.long 0

gfxstate:
vramaddr:
	.long 0
lineirq:
	.long 0
endframeline:
	.long 0
vblline:
	.long 0
scanlinebp:
	.long 0
scrollmask:
	.long 0
sprstop:
	.long 0
vdpregs:
vdpmode1:
	.byte 0
vdpmode2:
	.byte 0
nametable:
	.byte 0
ctoffset:
	.byte 0
pgoffset:
	.byte 0
satoffset:
	.byte 0
sproffset:
	.byte 0
bdcolor:
	.byte 0
vdpxscroll:
	.byte 0
vdpyscroll:
	.byte 0
vdpcounter:
	.byte 0

vdpctrl:
	.byte 0
vdpbuff:						;@ vdpbuff + toggle need to be together in this way.
	.byte 0,0
toggle:
	.byte 0,0
vdpstat:						;@ VBlank + spr stat
	.byte 0
vdppending:						;@ line interrupt pending
	.byte 0
vdpcalcmode:
	.byte 0
vdprmode:
	.byte 0
vdpheightmode:
	.byte 0
vdpmode2_bak1:
	.byte 0
vdpmode2_bak2:
	.byte 0
vdpyscroll1:					;@ tripple buffering
	.byte 0
vdpyscroll2:
	.byte 0
ntmask:
	.byte 0
minpan:
	.byte 0
maxpan:
	.byte 0
scrstartline:
	.byte 0
irqControl:
	.byte 0
irqPending:
	.byte 0
ystart:
	.byte 0
sprBank:
	.byte 0
scanlineminus:
	.byte 0
vdpbuff_md:
	.byte 0
hcountlatch:
	.byte 0
hcountoffset:
	.byte 0
vcountbp:
	.byte 0
hcountbp:
	.byte 0
SPRS:
	.byte 0			;@ SpriteScanning On/Off

sprmemalloc:
	.byte 0
sprmemreload:
	.byte 0
	.byte 0,0,0

	.pool
	.section .bss
VDP_RAM:
	.space 0x4000
	.space 0x4000
	.space 0x4000
	.space 0x4000
PALETTE_RAM:
	.space 0x80
CHR_DECODE:
	.space 0x400
DirtyTilesBackup:
	.space 0x200
SMSOAMBUFF:
	.space 0x180
OAM_BUFFER1:
	.space 0x400
OAM_BUFFER2:
	.space 0x400
DMA0BUFF:
	.space 0x1100				;@ actually 0x1000 plus extra
SCROLLBUFF:
	.space 316					;@ horizontal Scrollbuffer.
TMAPBUFF:
	.space 240
MAPPED_RGB:
	.space 0x2000
EMUPALBUFF:
	.space 0x400
;@...update load/savestate if you move things around in here
;@----------------------------------------------------------------------------

