#include "nds_asm.h"
#include "ARMZ80/z80mac.h"
#include "armsdtmac.h"
#include "equates.h"
//	INCLUDE memory.h
//	INCLUDE gfx.h
//	INCLUDE cart.h
//	INCLUDE z80.h
//	INCLUDE sound.h

	.arm
	.align 4
	.section .text

	.global IO_reset
	.global Z80_IN
	.global Z80_OUT
	.global Z80_IN_C
	.global Z80_OUT_C
	.global joycfg
	.global joy0state
	.global spriteinit
	.global refreshEMUjoypads
	.global Bin2BCD
	.global VDPdata_W_ptr




io_params:
;@sg1000
	.long empty_R_SMS1, empty_R_SMS1, empty_R_SMS1, empty_R_SMS1, VDPdata_R, VDPstat_R, ExtIO_0_SG_R,    ExtIO_1_SG_R
	.long empty_W,      empty_W,      SN76496_W,    SN76496_W,    VDPdata_W, VDPctrl_W, ExternalIO_SG_W, ExternalIO_SG_W

;@sms1
	.long empty_R_SMS1,  empty_R_SMS1, VCounter_R, HCounter_R, VDPdata_R, VDPstat_R, ExtIO_0_SMS_R, ExtIO_1_SMS_R
	.long MemCtrl_SMS_W, IOCtrl_SMS_W, SN76496_W,  SN76496_W,  VDPdata_W, VDPctrl_W, ExternalIO_W,  ExternalIO_W

;@sms2
	.long empty_R,       empty_R,      VCounter_R, HCounter_R, VDPdata_R, VDPstat_R, ExtIO_0_SMS_R, ExtIO_1_SMS_R
	.long MemCtrl_SMS_W, IOCtrl_SMS_W, SN76496_W,  SN76496_W,  VDPdata_W, VDPctrl_W, ExternalIO_W,  ExternalIO_W

;@gg_smsmode
	.long empty_R,      empty_R,      VCounter_R, HCounter_R, VDPdata_R, VDPstat_R, ExtIO_0_GGMD_R, ExtIO_1_GGMD_R
	.long MemCtrl_GG_W, IOCtrl_SMS_W, SN76496_W,  SN76496_W,  VDPdata_W, VDPctrl_W, ExternalIO_W,   ExternalIO_W

;@md
	.long empty_R,       empty_R,      VCounter_R, HCounter_R, VDPdata_R, VDPstat_R, ExtIO_0_GGMD_R, ExtIO_1_GGMD_R
	.long MemCtrl_SMS_W, IOCtrl_SMS_W, SN76496_W,  SN76496_W,  VRAM_MD_W, VDPctrl_MD_W, ExternalIO_W,   ExternalIO_W

;@gg_ggmode
	.long Low0_IO_R,    Low1_IO_R,   VCounter_R, HCounter_R, VDPdata_R, VDPstat_R, ExtIO_0_GGMD_R, ExtIO_1_GGMD_R
	.long MemCtrl_GG_W, IOCtrl_GG_W, SN76496_W,  SN76496_W,  VDPdata_W, VDPctrl_W, ExternalIO_W,   ExternalIO_W

;@sg1000 arcade
	.long empty_R_SMS1, empty_R_SMS1, empty_R_SMS1, empty_R_SMS1, VDPdata_R, VDPstat_R, ExtIO_0_SGAC_R,    ExtIO_1_SGAC_R
	.long empty_W,      empty_W,      SN76496_W,    SN76496_W,    VDPdata_W, VDPctrl_W, ExternalIO_SG_W, ExternalIO_SG_W

empty_R_ptr:
	.long empty_R
;@----------------------------------------------------------------------------
IO_reset:
;@----------------------------------------------------------------------------
	ldr r0,=g_machine
	ldrb r0,[r0]

	cmp r0,#HW_MD
	mov r1,#0xC0
	moveq r1,#0xE0				;@ Bit 5 is different on MD.
	strb r1,joyExtra
	mov r1,#0x07
	strb r1,SG_OutputSelect

	cmp r0,#HW_SMS1
	cmpne r0,#HW_SG1000
	ldr r1,=empty_R
	ldreq r1,=empty_R_SMS1
	str r1,empty_R_ptr
	sub r0,r0,#1
	ldr r1,=g_emuflags
	ldrb r1,[r1]
	tst r1,#GG_MODE
	movne r0,#5
	tst r1,#SGAC_MODE
	movne r0,#6
	adr r8,io_params
	add r8,r8,r0,lsl#6

	ldmia r8!,{r0-r7}
	ldr r9,=IN_Table
	stmia r9,{r0-r7}

	ldmia r8!,{r0-r7}
	ldr r9,=OUT_Table
	stmia r9,{r0-r7}



	ldr r2,=GGIO_Default
	ldmia r2!,{r0-r1}
	stmia r2,{r0-r1}

	bx lr
;@----------------------------------------------------------------------------
Bin2BCD:		;@ called from ui.c
;@----------------------------------------------------------------------------
	stmfd sp!,{r4}

	mov r1,#0
	adr r3,BCD_table			;@ BCD
	ldr r12,=0x11111110			;@ carry count mask value

Bin2BCD_loop:
	ldr r2,[r3],#4				;@ BCD (read BCD table)
	movs r0,r0,lsr#1			;@ test bit

	bcc Bin2BCD_loop_check
Bin2BCD_calc:
	add r4,r2,r1				;@ r4 = r2 + r1
	eor r2,r1,r2				;@ r2 = r1 XOR r2
	eor r2,r4,r2				;@ r2 = r4 XOR r2
	bic r2,r12,r2				;@ r2 = 0x11111110 AND NOT r2
	orr r2,r2,r2,lsr#1			;@ r2 = r2 OR (r2 LSR 1)
	sub r1,r4,r2,lsr#2			;@ r1 = r4 -  (r2 LSR 2)

Bin2BCD_loop_check:
	bne Bin2BCD_loop
	mov r0,r1

	ldmfd sp!,{r4}
	bx lr

BCD_table:
	.long 0x06666667
	.long 0x06666668
	.long 0x0666666a
	.long 0x0666666e
	.long 0x0666667c
	.long 0x06666698
	.long 0x066666ca
	.long 0x0666678e
	.long 0x066668bc
	.long 0x06666b78
	.long 0x0666768a
	.long 0x066686ae
	.long 0x0666a6fc
	.long 0x0666e7f8
	.long 0x0667c9ea
	.long 0x06698dce
	.long 0x066cbb9c
	.long 0x067976d8
	.long 0x068c87aa
	.long 0x06b8a8ee
	.long 0x076aebdc
	.long 0x086fd7b8
	.long 0x0a7fa96a
	.long 0x0e9eec6e
	.long 0x1cddd87c
	.long 0x39bbaa98
	.long 0x6d76eeca

;@----------------------------------------------------------------------------
refreshEMUjoypads:			;@call every frame
;@----------------------------------------------------------------------------
;@	mov r11,r11
		ldr r4,=frametotal
		ldr r4,[r4]
		movs r0,r4,lsr#2		;@ C=frame&2 (autofire alternates every other frame)
	ldr r1,=EMUinput
	ldr r1,[r1]
	mov r4,r1
	and r0,r1,#0xf0
		ldr r2,joycfg
		andcs r1,r1,r2
		tstcs r1,r1,lsr#9		;@ R?
		andcs r1,r1,r2,lsr#16
	adr addy,dulr2lrud
	ldrb r0,[addy,r0,lsr#4]		;@ downupleftright


	;@ paddle stuff
	;@--------------------------------
;@	ldrb r3,paddle0x
;@	tst r0,#0x8
;@	addne r3,r3,#2
;@	tst r0,#0x4
;@	subnes r3,r3,#2
;@	movmi r3,#0
;@	cmp r3,#0xFF
;@	movpl r3,#0xFF
;@	strb r3,paddle0x
	;@--------------------------------



	ands r3,r1,#3
	cmpne r3,#3
	tstne r2,#0x400				;@ Swap A/B?
	eorne r3,r3,#3

	orr r0,r0,r3,lsl#4

	ldr r3,=g_config_set
	ldrb r3,[r3]
	tst r3,#0x40
	tstne r4,#0x100				;@ R as Start?
	orrne r1,r1,#0x08
	and r1,r1,#0x08				;@ Start
	tst r3,#0x20
	tstne r4,#0x04				;@ Select as Reset?
	orrne r1,r1,#0x04
	orr r0,r0,r1,lsl#4

;@	tst r2,#0x80000000
;@	bne multi

	tst r2,#0x40000000			;@ Player2?
	streqb r0,joy0state
	strneb r0,joy1state
	bx lr

joycfg: .long 0x00ff05ff			;@ byte0=auto mask, byte1=(saves R), byte2=R auto mask
						;@ bit 31=single/multi, 30,29=1P/2P, 27=(multi) link active, 24=reset signal received
nrplayers:	.long 0		;@ Number of players in multilink.
joy0state:	.byte 0
joy1state:	.byte 0
joy2state:	.byte 0
joyExtra:	.byte 0
dulr2lrud:	.byte 0x00,0x08,0x04,0x0C, 0x01,0x09,0x05,0x0D, 0x02,0x0A,0x06,0x0E, 0x03,0x0B,0x07,0x0F

;@----------------------------------------------------------------------------
ExtIO_0_SGAC_R:
;@----------------------------------------------------------------------------
	cmp addy,#0xDC
	beq SGAC_P1
	cmp addy,#0xDE
	beq SGAC_DSW
	ldr pc,empty_R_ptr
;@----------------------------------------------------------------------------
SGAC_P1:					;@ SG-1000 Arcade input P1
;@----------------------------------------------------------------------------
	ldrb r0,joy0state
	tst r0,#0x80
	and r0,r0,#0x3F
	orrne r0,r0,#0x40
	eor r0,r0,#0xFF
	bx lr
;@----------------------------------------------------------------------------
ExtIO_1_SGAC_R:
;@----------------------------------------------------------------------------
	cmp addy,#0xDD
	ldrne pc,empty_R_ptr
;@----------------------------------------------------------------------------
SGAC_P2:					;@ SG-1000 Arcade input P2
;@----------------------------------------------------------------------------
	ldrb r0,joy0state
	and r0,r0,#0xBF
	eor r0,r0,#0xFF
	bx lr
;@----------------------------------------------------------------------------
SGAC_DSW:					;@ SG-1000 Arcade dipswitch
;@----------------------------------------------------------------------------
//	ldrb r0,joy0state
//	and r0,r0,#0x3F

	mov r0,#0
	ldr r1,=g_emuflags
	ldrb r1,[r1]
	tst r1,#COUNTRY		;@ JP bit?
	orreq r0,#0x80
	eor r0,r0,#0xFF
	bx lr

;@----------------------------------------------------------------------------
ExtIO_0_SG_R:
;@----------------------------------------------------------------------------
	cmp addy,#0xC0
	cmpne addy,#0xDC
	cmpne addy,#0xDE
	ldrne pc,empty_R_ptr
	ldrb r0,SG_OutputSelect
	cmp addy,#0xDE
	bxeq lr
	and r0,r0,#7
	cmp r0,#7
	movne r0,#0xFF
	bxne lr
	b IOPortA_R
;@----------------------------------------------------------------------------
ExtIO_0_GGMD_R:
;@----------------------------------------------------------------------------
	cmp addy,#0xC0
	cmpne addy,#0xDC
	beq IOPortA_R
	ldr pc,empty_R_ptr
;@----------------------------------------------------------------------------
ExtIO_0_SMS_R:
;@----------------------------------------------------------------------------
;@	mov r11,r11					;@ No$GBA breakpoint
	ldr r0,=BankMap4
	ldrb r0,[r0]
	tst r0,#0x04				;@ IO ports 0xC0 -> 0xFF enable/disable.
	ldrne pc,empty_R_ptr
;@----------------------------------------------------------------------------
IOPortA_R:					;@ Player1...
;@----------------------------------------------------------------------------
	ldrb r0,joy0state
	and r0,r0,#0x3F
	ldrb r1,joy1state
	and r1,r1,#0x03
	orr r0,r0,r1,lsl#6
	eor r0,r0,#0xFF
	bx lr

;@----------------------------------------------------------------------------
ExtIO_1_SG_R:
;@----------------------------------------------------------------------------
	cmp addy,#0xC1
	cmpne addy,#0xDD
	ldrne pc,empty_R_ptr
	ldrb r0,SG_OutputSelect
	and r0,r0,#7
	cmp r0,#7
	movne r0,#0xFF
	bxne lr
	b IOPortB_R
;@----------------------------------------------------------------------------
ExtIO_1_GGMD_R:
;@----------------------------------------------------------------------------
	cmp addy,#0xC1
	cmpne addy,#0xDD
	beq IOPortB_R
	ldr pc,empty_R_ptr
;@----------------------------------------------------------------------------
ExtIO_1_SMS_R:
;@----------------------------------------------------------------------------
;@	mov r11,r11					;@ No$GBA breakpoint
	ldr r0,=BankMap4
	ldrb r0,[r0]
	tst r0,#0x04				;@ IO ports 0xC0 -> 0xFF enable/disable.
	ldrne pc,empty_R_ptr
;@----------------------------------------------------------------------------
IOPortB_R:					;@ Player2...
;@----------------------------------------------------------------------------
	ldrb r0,joy0state
	and r0,r0,#0x40				;@ Reset is taken from both players.
	ldrb r1,joy1state
	and r1,r1,#0x7C
	orr r0,r0,r1
	ldrb r1,joyExtra
	orr r0,r1,r0,lsr#2
	eor r0,r0,#0x3F
	bx lr

;@----------------------------------------------------------------------------
Low0_IO_R:					;@ GG start button & country
;@----------------------------------------------------------------------------
	ands addy,addy,#0xFF
	bne Low1_IO_R

	ldr r1,=g_emuflags
	ldrb r1,[r1]
	and r1,r1,#3				;@ Jap / PAL bits
	ldrb r0,joy0state			;@ Port 0x00
	and r0,r0,#0x80
	orr r0,r0,r1,lsl#5
;@	orr r0,r0,#0x40				;@ JAP/EXPORT
;@	orr r0,r0,#0x20				;@ NTSC/PAL
	eor r0,r0,#0xC0
	bx lr
;@----------------------------------------------------------------------------
Low1_IO_R:					;@ GG com port stuff
;@----------------------------------------------------------------------------
	cmp addy,#6
	ldrhi pc,empty_R_ptr
	adr r1,GGIO
	ldrb r0,[r1,addy]
	bx lr

;@------------------------------------------------------------------------------
IOCtrl_GG_W:
;@------------------------------------------------------------------------------
	and addy,addy,#0xFF
	cmp addy,#6
	bhi IOCtrl_SMS_W
	adr r1,GGIO
	strb r0,[r1,addy]
	bx lr
GGIO_Default:
	.byte 0xC0,0x7F,0xFF,0x00,0xFF,0x00,0xFF,0
GGIO:
	.byte 0xC0,0x7F,0xFF,0x00,0xFF,0x00,0xFF,0
;@------------------------------------------------------------------------------
IOCtrl_SMS_W:
;@------------------------------------------------------------------------------
	ldr r1,=g_emuflags
	ldrb r1,[r1]
	tst r1,#2					;@ Jap bit
	bicne r0,r0,#0xF0
	orr r0,r0,r0,lsl#4
	and r0,r0,#0xA0				;@ only care about TH A/B right now.
	orr r0,r0,r0,lsl#1
	and r0,r0,#0xC0
	ldrb r1,joyExtra
	stmfd sp!,{r0,r2,lr}
	eor r2,r0,r1
	and r2,r2,r0
	ands r2,r2,#0xC0
	blne HCounter_Latch
	ldmfd sp!,{r0,r2,lr}
	
	bic r1,r1,#0xC0
	orr r0,r0,r1
	strb r0,joyExtra
	bx lr

	;@ paddle stuff
	;@--------------------------------
;@	ands r0,r0,#0x40
;@	ldrb r0,joy0state
;@	and r0,r0,#0xD0
;@	orrne r0,r0,#0x20
;@	ldrb r1,paddle0x
;@	andne r1,r1,#0x0f
;@	moveq r1,r1,lsr#4
;@	eor r1,r1,#0x0F
;@	orr r0,r0,r1
;@	strb r0,joy0state
	;@--------------------------------
	
;@	bx lr

;@------------------------------------------------------------------------------
MemCtrl_GG_W:
;@------------------------------------------------------------------------------
	cmp addy,#6
	bhi BankSwitchB_GG_W
	adr r1,GGIO
	strb r0,[r1,addy]
	beq GG_Stereo_W
	bx lr


;@----------------------------------------------------------------------------
ExternalIO_R:
;@----------------------------------------------------------------------------
	cmp addy,#0xF0				;@ FM Unit detect
	ldr pc,empty_R_ptr
	mov r0,#0xFF
	bx lr
;@----------------------------------------------------------------------------
ExternalIO_SG_W:
;@----------------------------------------------------------------------------
	cmp addy,#0xDE
	streqb r0,SG_OutputSelect
;@----------------------------------------------------------------------------
ExternalIO_W:
;@----------------------------------------------------------------------------
	cmp addy,#0xF7				;@ SysE Bank
	beq SysEBanking
	cmp addy,#0xFD				;@ SDC debugg
	bne empty_W
	bx lr
SG_OutputSelect:
	.byte 0x07,0,0,0
;@----------------------------------------------------------------------------
SysEBanking:
;@----------------------------------------------------------------------------
	and r0,r0,#0x0F				;@ Add banking for VRAM as well!!!
	add r0,r0,#2
	b BankSwitch2_W
;@----------------------------------------------------------------------------
Z80_IN_C:
;@----------------------------------------------------------------------------
	mov addy,z80bc,lsr#16
;@----------------------------------------------------------------------------
Z80_IN:
;@----------------------------------------------------------------------------
	and addy,addy,#0xFF
	mov r1,addy,lsl#31
	orr r1,r1,addy,lsr#6
	ldr pc,[pc,r1,ror#29]
	.long 0
IN_Table:
	.long empty_R
	.long empty_R
	.long VCounter_R
	.long HCounter_R
	.long VDPdata_R
	.long VDPstat_R
	.long ExtIO_0_SMS_R
	.long ExtIO_1_SMS_R
;@----------------------------------------------------------------------------
Z80_OUT_C:
;@----------------------------------------------------------------------------
	mov addy,z80bc,lsr#16
;@----------------------------------------------------------------------------
Z80_OUT:
;@----------------------------------------------------------------------------
	and addy,addy,#0xFF
	mov r1,addy,lsl#31
	orr r1,r1,addy,lsr#6
	ldr pc,[pc,r1,ror#29]
	.long 0
OUT_Table:
	.long MemCtrl_SMS_W
	.long IOCtrl_SMS_W
	.long SN_0_W
	.long SN_0_W
VDPdata_W_ptr:
	.long VDPdata_W
	.long VDPctrl_W
	.long ExternalIO_W
	.long ExternalIO_W
;@----------------------------------------------------------------------------

