#include <nds.h>
#include <fat.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/dir.h>

#include "gui.h"
#include "romloading.h"
#include "unzip/unzipnds.h"
#include "equates.h"

extern u8 ROM_Space[];				// cart.s
//extern int selectedGame;			// main.c
//extern int powerButton;				// main.c
//extern int pauseEmulation;			// main.c

//asm variables
extern u32 g_emuflags;				// cart.s

//extern void loadcart(int,int);		// cart.s
//extern void waitVBlank(void);		// main.c
//extern void pausVBlank(int count);	// main.c
//extern void setEmuSpeed(int speed);	// main.c


extern int fatAvailable;
extern char currentfilename[];
char *const megatechgames[]={"mt_aftrb.zip","mt_astro.zip","mt_asyn.zip",  "mt_gfoot.zip",  "mt_ggolf.zip","mt_gsocr.zip","mt_orun.zip",  "mt_parlg.zip","mt_shnbi.zip"};
char *const megatechfiles[]={"mp11271.ic1", "ep13817.ic2", "mpr-11194.ic1","mpr-10576f.ic1","mp11129f.ic1","mp10747f.ic1","mpr-11078.ic1","mp11404.ic1","mp11706.ic1"};
const int   megatechsizes[]={0x80000,       0x20000,       0x40000,        0x20000,         0x20000,       0x20000,       0x40000,        0x20000,      0x40000};
int loadArcadeROM(void* dest, const char* fName) {
	int i;
	int size = 0;
	char fNameLowercase[16];

//	drawtext("Checking for Arcade Roms", 23, 0);
	strcasel(fNameLowercase, fName);
	for(i=0;i<9;i++) {
		if(strstr(fNameLowercase, megatechgames[i])) {
			if( (loadFileInZip(dest, fName, megatechfiles[i], megatechsizes[i])) == 0) {
				size = cenhead.ucsize;
				strncpy(currentfilename,zipFilename,63);
				g_emuflags |=MD_MODE;
				return size;
			}
		}
	}

	if(strstr(fNameLowercase, "chboxing.zip")) {
		if( (loadFileInZip(dest, fName, "cb6105.bin", 0x4000)) == 0) {
			if( (loadFileInZip(dest+0x4000, fName, "cb6106.bin", 0x4000)) == 0) {
				if( (loadFileInZip(dest+0x8000, fName, "cb6107.bin", 0x2000)) == 0) {
					size = 0x10000;
					strncpy(currentfilename,"chboxing.sg",63);
					g_emuflags |=SGAC_MODE;
				}
			}
		}
	} else if(strstr(fNameLowercase, "chwrestl.zip")) {
		if( (loadFileInZip(dest, fName, "5732", 0x4000)) == 0) {
			if( (loadFileInZip(dest+0x4000, fName, "5733", 0x4000)) == 0) {
				if( (loadFileInZip(dest+0x8000, fName, "5734", 0x4000)) == 0) {
					size = 0x10000;
					strncpy(currentfilename,"chwrestl.sg",63);
					g_emuflags |=SGAC_MODE;
				}
			}
		}
	} else if(strstr(fNameLowercase, "dokidoki.zip")) {
		if( (loadFileInZip(dest, fName, "epr-7356.ic1", 0x4000)) == 0) {
			if( (loadFileInZip(dest+0x4000, fName, "epr-7357.ic2", 0x4000)) == 0) {
				if( (loadFileInZip(dest+0x8000, fName, "epr-7358.ic3", 0x4000)) == 0) {
					size = 0x10000;
					strncpy(currentfilename,"dokidoki.sg",63);
					g_emuflags |=SGAC_MODE;
				}
			}
		}
	} else if(strstr(fNameLowercase, "hangonjr.zip")) {
		if( (loadFileInZip(dest, fName, "rom5.ic7", 0x8000)) == 0) {
			if( (loadFileInZip(dest+0x8000, fName, "rom4.ic5", 0x8000)) == 0) {
				if( (loadFileInZip(dest+0x10000, fName, "rom3.ic4", 0x8000)) == 0) {
					if( (loadFileInZip(dest+0x18000, fName, "rom2.ic3", 0x8000)) == 0) {
						if( (loadFileInZip(dest+0x20000, fName, "rom1.ic2", 0x8000)) == 0) {
							size = 0x40000;
							strncpy(currentfilename,"HangOnJr",63);
						}
					}
				}
			}
		}
	} else if(strstr(fNameLowercase, "transfrm.zip")) {
		if( (loadFileInZip(dest, fName, "ic7.top", 0x8000)) == 0) {
			if( (loadFileInZip(dest+0x8000, fName, "epr-7347.ic5", 0x8000)) == 0) {
				if( (loadFileInZip(dest+0x10000, fName, "epr-7348.ic4", 0x8000)) == 0) {
					if( (loadFileInZip(dest+0x18000, fName, "ic3.top", 0x8000)) == 0) {
						if( (loadFileInZip(dest+0x20000, fName, "epr-7350.ic2", 0x8000)) == 0) {
							size = 0x40000;
							strncpy(currentfilename,"Transformers",63);
						}
					}
				}
			}
		}
	}
	return size;
}

void strcasel(char * dest, const char* source) {
	int i;

	strncpy(dest, source, 15);
	for(i=0;i<16;i++) {
		if(dest[i] > 0x40 && dest[i] < 0x5B) dest[i] |= 0x20;
	}
}