#include "equates.h"
#include "nds_asm.h"
#include "SN76496\sn76496_equ.h"

	.global Sound_init
	.global Sound_reset
	.global Sound_set_frequency
	.global Vbl_Sound_2
	.global SN_0_W
	.global SN76496_W
	.global SN76496_0
	.global GG_Stereo_W
	.global SoundVariables
	.extern pauseEmulation
	.extern powerButton


;@----------------------------------------------------------------------------

	.arm
	.align 4
	.section .text

;@----------------------------------------------------------------------------
Sound_init:
;@----------------------------------------------------------------------------
	stmfd sp!,{lr}

	ldr snptr,=SN76496_0
	mov r1,#1
	bl SN76496_set_mixrate		;@ sound, 0=low, 1=high mixrate
	bl Sound_set_frequency

	ldmfd sp!,{lr}
//	bx lr

;@----------------------------------------------------------------------------
Sound_reset:
;@----------------------------------------------------------------------------
	ldr snptr,=SN76496_0
	ldr r1,pcmptr0
	str r1,[snptr,#pcmptr]

	ldr r1,=g_machine
	ldrb r1,[r1]
	cmp r1,#HW_SG1000
	mov r1,#0
	moveq r1,#1
	b SN76496_reset				;@ sound
;@----------------------------------------------------------------------------
Sound_set_frequency:
;@----------------------------------------------------------------------------
	stmfd sp!,{lr}
	ldr snptr,=SN76496_0
	ldr r1,=g_emuflags
	ldrb r1,[r1]
	tst r1,#PALTIMING
	ldr r1,=3579545				;@ NTSC freq
	ldrne r1,=3546893			;@ PAL freq
	bl SN76496_set_frequency	;@ sound, chip frequency
	ldmfd sp!,{lr}
	ldr r1,=FREQTBL
	b SN76496_init				;@ sound

;@----------------------------------------------------------------------------
Vbl_Sound_2:				;@ r0=length, r1=pointer
;@----------------------------------------------------------------------------
;@	mov r11,r11
	stmfd sp!,{r0,r1,lr}

	ldr r1,=pauseEmulation		;@ Output silence when emulation paused.
	ldr r1,[r1]
	cmp r1,#0
	bne silenceMix
	ldr r1,=powerButton			;@ Output silence when power off.
	ldr r1,[r1]
	cmp r1,#0
	beq silenceMix

	mov r1,r0
	ldr r0,=SN76496_0
	str r1,[r0,#mixlength]
	bl SN76496_mixer

	ldmfd sp!,{r0,r1}
	mov r12,r0
	ldr r3,pcmptr0
wavloop:
	ldr r2,[r3],#4
	str r2,[r1],#4
	subs r12,r12,#1
	bhi wavloop

	ldmfd sp!,{lr}
	bx lr

silenceMix:
	ldmfd sp!,{r0,r1}
	mov r12,r0
	mov r2,#0
silenceLoop:
	str r2,[r1],#4
	subs r12,r12,#1
	bhi silenceLoop

	ldmfd sp!,{lr}
	bx lr

;@----------------------------------------------------------------------------
GG_Stereo_W:
;@----------------------------------------------------------------------------
	stmfd sp!,{r3,lr}
	mov r1,r0
	ldr r0,=SN76496_0
	bl SN76496_GG_w
	ldmfd sp!,{r3,lr}
	bx lr
;@----------------------------------------------------------------------------
SN76496_W:
SN_0_W:
;@----------------------------------------------------------------------------
	stmfd sp!,{r3,lr}
	mov r1,r0
	ldr r0,=SN76496_0
	bl SN76496_w
	ldmfd sp!,{r3,lr}
	bx lr

;@----------------------------------------------------------------------------

pcmptr0:	.long WAVBUFFER
pcmptr1:	.long WAVBUFFER+(528*4)

	.section .bss
SoundVariables:
SN76496_0:
	.space sn_size
FREQTBL:
	.space 1024*2
WAVBUFFER:
	.space 0x2000
;@----------------------------------------------------------------------------
	.end
